#include "file.h"

extern _GfxWin *mainwin;
extern int _BankNumber;
extern char *_locale[];
extern _MainStruct mainstruct;
extern struct _wconfig _WConfig;

bool _CheckFilter(char *name,int nr)
{ /* Prft, ob die Datei <name> im Lister <nr> angezeigt werden darf */
  _Filter *f,*tf;
  bool returnvalue,end;
  int ins,outs;
  
  f=mainstruct.lister[nr].first_filter;
  tf=f;
  ins=0;
  outs=0;
  while(tf!=NULL) {
    if(tf->check==1) ins++;
    if(tf->check==2) outs++;
    tf=tf->next;
  }
  if(ins>0) returnvalue=FALSE;
  else returnvalue=TRUE;
  end=FALSE;
  if(f==NULL) returnvalue=TRUE;
  else {
    if(strcmp(name,"..")==0) returnvalue=TRUE;
    else {
      do {
        if(f->check>0) {
          if(fnmatch(f->pattern,name,0)==0) {
            if(f->check==1) returnvalue=TRUE; else returnvalue=FALSE;
            end=TRUE;
          }
        }
        f=f->next;
      } while((f!=NULL)&&(end==FALSE));
    }
  }
  return returnvalue;
}

_FileEntry *_ReadDir(const char *dirstr)
{ /* Liest Verzeichnis <dirstr> ein und gibt unsortierte Liste zurck */
  struct dirent *namelist;
  struct stat stbuf;
  DIR *dir;
  _FileEntry *fe1,*fe2;
  char *tstr;
  long x,ldnr;
  fe1=NULL;
  fe2=NULL;
  dir=opendir(dirstr);
  if(dir!=NULL) {
    readdir(dir);  /* berspringt den Eintrag "." */
    ldnr=0;
    while((namelist=readdir(dir))!=NULL) {
      if(fe1==NULL) {
        fe1=(_FileEntry*)_allocsafe(sizeof(_FileEntry));
        fe1->prev=NULL;
        fe2=fe1;
      } else {
        fe1->next=(_FileEntry*)_allocsafe(sizeof(_FileEntry));
        fe1->next->prev=fe1;
        fe1=fe1->next;
      }
      fe1->name=NULL;
      fe1->fullname=NULL;
      fe1->next=NULL;
      x=strlen(namelist->d_name);
      tstr=(char*)_allocsafe(x+1);
      strcpy(tstr,namelist->d_name);
      fe1->name=tstr;
      tstr=(char*)_allocsafe(strlen(dirstr)+1+x+1);
      strcpy(tstr,dirstr);
      if(strlen(dirstr)>1) strcat(tstr,"/");
      strcat(tstr,namelist->d_name);
      fe1->fullname=tstr;
      if(stat(fe1->fullname,&stbuf)==0) {
        fe1->size=stbuf.st_size;
        fe1->lastaccess=stbuf.st_atime;
        fe1->lastmod=stbuf.st_mtime;
        fe1->lastchange=stbuf.st_ctime;
        fe1->mode=stbuf.st_mode;
        fe1->userid=stbuf.st_uid;
        fe1->groupid=stbuf.st_gid;
        fe1->iscorrupt=FALSE;
      } else {
        /* Falls das ein Link ist, dann ist er korrupt */
        fe1->iscorrupt=TRUE;
        if(errno==ENOENT) {
        }
      }
      if(lstat(fe1->fullname,&stbuf)==0) {
        fe1->lsize=stbuf.st_size;
        fe1->llastaccess=stbuf.st_atime;
        fe1->llastmod=stbuf.st_mtime;
        fe1->llastchange=stbuf.st_ctime;
        fe1->lmode=stbuf.st_mode;
        fe1->luserid=stbuf.st_uid;
        fe1->lgroupid=stbuf.st_gid;
      }
      if(S_ISLNK(fe1->lmode)) {
        fe1->islink=TRUE;
      } else {
        fe1->islink=FALSE;
      }
      fe1->select=FALSE;
      fe1->dirsize=-1;
      fe1->filetypeindex=-2;
      fe1->filetype=NULL;
      fe1->nr=ldnr++;
      fe1->infilter=TRUE;
    }
    closedir(dir);
/*    free(namelist);*/
  }
  return fe2;
}

void _FreeDir(_FileEntry *first)
{
  _FileEntry *fe1,*fe2;
  fe1=first;
  while(fe1!=NULL) {
    fe2=fe1->next;
    if(fe1->name!=NULL) _freesafe(fe1->name);
    if(fe1->fullname!=NULL) _freesafe(fe1->fullname);
    _freesafe(fe1);
    fe1=fe2;
  }
}

_FileEntry *_SortDir(_FileEntry *first,int sortmode2)
{
  /* ToDo: Anderer Sort-Algorithmus, im Moment wird O(n*n) benutzt */
  _FileEntry *sortedfirst,*fe1,*small,*start,temp,*ffile,*fe2,*parententry;
  int sortmode,reverse;
  long smallsize,size;
  if(first==NULL) return NULL;
  parententry=first;
  sortedfirst=NULL;
  start=first->next;
  sortmode=sortmode2&0x7f;
  reverse=sortmode2&0x80;
  if(start!=NULL) start->prev=NULL;
  while(start!=NULL) {
    small=start;
/*    if(S_ISDIR(small->mode)) {
      if(S_ISLNK(small->lmode)) {
        if(small->dirsize>=0) smallsize=small->dirsize; else smallsize=small->lsize;
      } else {
        if(small->dirsize>=0) smallsize=small->dirsize; else smallsize=small->size;
      }
    } else {
      if(S_ISLNK(small->lmode)) smallsize=small->lsize; else smallsize=small->size;
    }*/    /* dies wird seit 21.2.99 ersetzt durch das neue Flag islink */
    if(small->iscorrupt==FALSE) {
      if(S_ISDIR(small->mode)) {
        if(small->islink==TRUE) {
          if(small->dirsize>=0) smallsize=small->dirsize; else smallsize=small->lsize;
        } else {
          if(small->dirsize>=0) smallsize=small->dirsize; else smallsize=small->size;
        }
      } else {
        if(small->islink==TRUE) smallsize=small->lsize; else smallsize=small->size;
      }
    } else {
      if(small->islink==TRUE) smallsize=small->lsize; else smallsize=small->size;
    }
    fe1=start->next;
    while(fe1!=NULL) {
      switch(sortmode) {
        case SORT_SIZE:if((S_ISDIR(fe1->mode))&&(fe1->iscorrupt==FALSE)) {
                         if(fe1->islink==TRUE) {
                           if(fe1->dirsize>=0) size=fe1->dirsize; else size=fe1->lsize;
                         } else {
                           if(fe1->dirsize>=0) size=fe1->dirsize; else size=fe1->size;
                         }
                       } else {
                         if(fe1->islink==TRUE) size=fe1->lsize; else size=fe1->size;
                       }
                       if(reverse==0x80) {
                         if(size>smallsize) {
                           small=fe1;
                           smallsize=size;
                         }
                       } else {
                         if(size<smallsize) {
                           small=fe1;
                           smallsize=size;
                         }
                       }
                       break;
        case SORT_ACCESS:if(reverse==0x80) {
                           if(fe1->lastaccess<small->lastaccess) small=fe1;
                         } else {
                           if(fe1->lastaccess>small->lastaccess) small=fe1;
                         }
                         break;
        case SORT_MODIFICATION:if(reverse==0x80) {
                                 if(fe1->lastmod<small->lastmod) small=fe1;
                               } else {
                                 if(fe1->lastmod>small->lastmod) small=fe1;
                               }
                               break;
        case SORT_CHANGE:if(reverse==0x80) {
                           if(fe1->lastchange<small->lastchange) small=fe1;
                         } else {
                           if(fe1->lastchange>small->lastchange) small=fe1;
                         }
                         break;
        default:if(reverse==0x80) {
                  if(strcmp(fe1->name,small->name)>0) small=fe1;
                } else {
                  if(strcmp(fe1->name,small->name)<0) small=fe1;
                }
      }
      fe1=fe1->next;
    }
    if(small!=start) {
      if(start->next!=small) {
        temp.next=small->next;
        temp.prev=small->prev;
        small->prev=start->prev;
        small->next=start->next;
        start->prev=temp.prev;
        start->next=temp.next;
        if(small->prev==NULL) sortedfirst=small;
        else {
          small->prev->next=small;
        }
        small->next->prev=small;
        start->prev->next=start;
        if(start->next!=NULL) start->next->prev=start;
      } else {
        temp.next=small->next;
        temp.prev=start->prev;
        small->prev=temp.prev;
        small->next=start;
        start->prev=small;
        start->next=temp.next;
        if(small->prev==NULL) sortedfirst=small;
        else {
          small->prev->next=small;
        }
        if(start->next!=NULL) start->next->prev=start;
      }
      start=small->next;
    } else {
      if(start->prev==NULL) sortedfirst=start;
      start=start->next;
    }
  }
  fe1=sortedfirst;
  if(fe1!=NULL) {
    ffile=fe1;
    while((ffile->mode&S_IFDIR)==S_IFDIR) {
      if(ffile->next==NULL) break;
      if(ffile->iscorrupt==TRUE) break;
      ffile=ffile->next;
    }
    fe2=ffile->next;
    while(fe2!=NULL) {
      if(((fe2->mode&S_IFDIR)!=S_IFDIR)||(fe2->iscorrupt==TRUE)) {
        fe2=fe2->next;
      } else {
        /* fe2 vor ffile setzen */
        temp.prev=fe2->prev;
        temp.next=fe2->next;
        if(ffile->prev==NULL) {
          sortedfirst=fe2;
          ffile->prev=fe2;
          fe2->next=ffile;
          temp.prev->next=temp.next;
          if(temp.next!=NULL) temp.next->prev=temp.prev;
        } else {
          ffile->prev->next=fe2;
          fe2->prev=ffile->prev;
          fe2->next=ffile;
          ffile->prev=fe2;
          temp.prev->next=temp.next;
          if(temp.next!=NULL) temp.next->prev=temp.prev;
        }
        fe2=temp.next;
      }
    }
  }
  if(sortedfirst==NULL) {
    sortedfirst=parententry;
    parententry->next=NULL;
  } else {
    sortedfirst->prev=parententry;
    parententry->next=sortedfirst;
    sortedfirst=parententry;
  }
  return sortedfirst;
}

char *_Parent(const char *pathstr,char *dirnamereturn)
{
  char *newpath;
  int x,y;
  x=strlen(pathstr);
  if(x<2) {
    newpath=(char*)_allocsafe(2);
    strcpy(newpath,"/");
    if(dirnamereturn!=NULL) strcpy(dirnamereturn,"");
  } else {
    if(pathstr[x-1]=='/') y=x-2; else y=x-1;
    while((pathstr[y]!='/')&&(y>0)) {
      y--;
    }
    if(y==0) {
      newpath=(char*)_allocsafe(2);
      strcpy(newpath,"/");
      if(dirnamereturn!=NULL) strcpy(dirnamereturn,pathstr+1);
    } else {
      newpath=(char*)_allocsafe(y+1);
      strncpy(newpath,pathstr,y);
      if(dirnamereturn!=NULL) strcpy(dirnamereturn,pathstr+y+1);
      newpath[y]=0;
    }
  }
  return newpath;
}

char *_HandlePath(const char *pathstr)
{
  char *newpath,*newpath2,buffer[1024];
  int x,y,parentlevel;
  int start,end;
  int found,ende;
  x=strlen(pathstr);
  y=0;
  found=0;
  parentlevel=0;
  ende=0;
  newpath=(char*)_allocsafe(1);
  newpath[0]=0;
  do {
    start=y;
    while((pathstr[y]!='/')&&((y+1)<x)) {
      y++;
    }
    if(((y+1)>=x)&&(pathstr[y]!='/')) end=y+1; else end=y;
    if(end>start) {
      strncpy(buffer,pathstr+start,end-start);
      buffer[end-start]=0;
      if(strcmp(buffer,".")==0) {
        y++;
      } else if(strcmp(buffer,"..")==0) {
        y++;
        newpath2=_Parent(newpath,NULL);
        _freesafe(newpath);
        newpath=newpath2;
      } else {
        newpath2=(char*)_allocsafe(strlen(newpath)+1+strlen(buffer)+1);
        strcpy(newpath2,newpath);
        if(strlen(newpath)>0) {
          if(newpath[strlen(newpath)-1]!='/') strcat(newpath2,"/");
        }
        strcat(newpath2,buffer);
        _freesafe(newpath);
        newpath=newpath2;
        y++;
      }
    } else {
      if(start==0) {
        newpath2=(char*)_allocsafe(2);
        strcpy(newpath2,"/");
        _freesafe(newpath);
        newpath=newpath2;
      }
      y++;
    }
    if(y>=x) ende=1;
  } while(ende==0);
  return newpath;
}

struct _filetypedef *_CheckFiletype(_FileEntry *fe)
{
  unsigned char fbuffer[64];
  int reads,x,entry,found,y,minsize=0;
  struct _filetypedef *ft;
  FILE *fp;
  if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) return NULL;
/*  if(fe->islink==TRUE) {
    if(!S_ISREG(fe->lmode)) {
      fe->filetypeindex=-1;
      return NULL;
    }
  } else {*/
    if(!S_ISREG(fe->mode)) {
      fe->filetypeindex=-1;
      return NULL;
    }
/*  }*/
  if(fe->size<1) {
    fe->filetypeindex=-1;
    return NULL;
  }
  if(_WConfig.firsttype==NULL) return NULL;
#ifdef ZLIB
  #define fopen gzopen
  #define fclose gzclose
  #define fread(B,N,L,F) gzread(F,B,(L)*(N))
#endif
  fp=fopen(fe->fullname,"r");
  if(fp!=NULL) {
    reads=fread(fbuffer,1,64,fp);
    fclose(fp);
    ft=_WConfig.firsttype;
    entry=0;
    found=-1;
    for(;;) {
      if(ft->usefiledesc==TRUE) {
        for(x=0;x<64;x++) {
          if(ft->filedesc[x]>-1) minsize=x+1;
        }
        if(reads>=minsize) {
          y=0;
          for(x=0;x<reads;x++) {
            if(ft->filedesc[x]>=0) {
              if(ft->filedesc[x]!=(int)fbuffer[x]) {
                y=1;
                break;
              }
            }
          }
          if(y==0) {
            found=entry;
            break;
          }
        }
      }
      if(ft->usepattern==TRUE) {
        x=fnmatch(ft->pattern,fe->name,0);
        if(x==0) {
          found=entry;
          break;
        }
      }
      ft=ft->next;
      entry++;
      if(ft==NULL) break;
    }
    fe->filetypeindex=found;
    if(found>=0) fe->filetype=ft; else fe->filetype=NULL;
    return ft;
  }
  return NULL;
#ifdef ZLIB
  #undef fopen
  #undef fclose
  #undef fread
#endif
}

