#include "normalmode.h"

extern _GfxWin *mainwin;
extern _MainStruct mainstruct;
extern char *_locale[];
extern char *_localecoms[];
extern char _UFlags[][5];
extern int _NBH;
extern int _BBH;
extern struct _wconfig _WConfig;
extern struct _globalgui _GlobalGUI;

/* lokale Prototypen */
void _NL_ChangeActive(int mode,_RealLister *rl,int nr,_FileEntry *fe);
void _BuildLVC(_FileEntry *fe,_ListViewContent *lvc,int nr);
int _NL_RecCopy(_CDirEntry *tdir,_GfxWin *gfxwin,_ListView *lv,int maxdisplayv,char *destpath,bool *abbruch,long *flag,unsigned long *files,unsigned long *dirs,unsigned long bytes[2],time_t *starttimep);
void _NL_SetCopyWinText(_GfxWin *gfxwin,char *text[2]);

void _NL_on(int nr)
{
  /* Schaltet Lister nr auf normale Dateianzeige */
  int mode;
  struct _button *lvb;
  char *str;
  void (*off)(int);
  mode=mainstruct.lister[nr].activemode;  /* derzeitigen Modus lesen */
  if(mode==0) return;                     /* wenn 0, dann schon aktiv */
  if(mode>0) {                            /* sonst ausschalten */
    off=mainstruct.mode_info[mode].off;
    if(off!=NULL) (*off)(nr);
  }
  _NL_RebuildLister(nr);                  /* Listerinhalt neu aufbauen */
  if(nr==mainstruct._ActiveLV) _NL_activate();
  mainstruct.lister[nr].activemode=0;
  mainstruct.lister[nr].lv->sel_proc=_NL_SelectProc;
  lvb=mainstruct.lister[nr].lvb;
  str=(char*)_allocsafe(strlen(mainstruct.mode_info[0].name)+3+strlen(_locale[189])+1);
  sprintf(str,"%s - %s",mainstruct.mode_info[0].name,_locale[189]);
  _freesafe(lvb->text_normal);
  lvb->text_normal=str;
  _RedrawWin(mainwin);
}

void _NL_off(int nr)
{
  /* Schaltet normale Dateianzeige in Lister nr aus */
  _ListView *lv;
  _ListViewContent *lvc;
  struct _button *lvb;
  char *str;
  if(nr==mainstruct._ActiveLV) _NL_deactivate();
  lv=mainstruct.lister[nr].lv;  
  lvc=lv->first;
  while(lvc!=NULL) {
    _RemoveListViewContent(mainwin,lv,lvc);
    lvc=lv->first;
  }
  mainstruct.lister[nr].activemode=-1;
  lv->sel_proc=NULL;
  lvb=mainstruct.lister[nr].lvb;
  str=(char*)_allocsafe(1);
  str[0]=0;
  _freesafe(lvb->text_normal);
  lvb->text_normal=str;
  _RedrawWin(mainwin);
}

void _NL_activate(void)
{
  _RealLister *rl;
  _Button *lvb;
  _SolidButton *statebar;
  _ListViewContent *lvc;
  _FileEntry *fe;
  int nr;
  int fg,bg;
/*  char *tstr,buf[3];*/
/*  int x,y;*/

  nr=mainstruct._ActiveLV;
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;  
  lvb=mainstruct.lister[nr].lvb;
  statebar=mainstruct.statebar;
  fg=_WConfig.sel_lvbfg;
  bg=_WConfig.sel_lvbbg;
  lvb->fg_normal=fg;
  lvb->bg_normal=bg;
  if(rl->FEDir[nr]!=NULL) {
/*    tstr=(char*)_allocsafe(strlen(_locale[107])+strlen(_locale[108])+100);
    x=rl->selbytes[nr];
    y=0;
    if(x>(1024*1024*10)) {
      y=1;
      x/=1024*1024;
      strcpy(buf,"MB");
    } else if(x>(1024*1024)) {
      y=1;
      x/=1024;
      strcpy(buf,"KB");
    }
    _freesafe(statebar->text);
    statebar->text=tstr;
    if(y==1) {
      sprintf(tstr,"%s:%ld/%ld %s:%ld/%ld %s:%ld | %d %s",_locale[107],rl->filenr[nr][0],rl->filenr[nr][1],_locale[108],rl->dirnr[nr][0],rl->dirnr[nr][1],_locale[13],rl->selbytes[nr],x,buf);
    } else {
      sprintf(tstr,"%s:%ld/%ld %s:%ld/%ld %s:%ld",_locale[107],rl->filenr[nr][0],rl->filenr[nr][1],_locale[108],rl->dirnr[nr][0],rl->dirnr[nr][1],_locale[13],rl->selbytes[nr]);
    }*/
    _NL_UpdateStatebar();
    lvc=mainstruct.lister[nr].lv->first;
    fe=rl->activefe[nr];
    if(fe!=NULL) {
      while(lvc!=NULL) {
        if(lvc->data==fe->nr) {
          lvc->active=TRUE;
          break;
        }
        lvc=lvc->next;
      }
    }
  }
  _RedrawWin(mainwin);
}

void _NL_deactivate(void)
{
  _RealLister *rl;
  _Button *lvb;
  _SolidButton *statebar;
  _ListViewContent *lvc;
  int nr;
  int fg,bg;

  nr=mainstruct._ActiveLV;
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;  
  lvb=mainstruct.lister[nr].lvb;
  statebar=mainstruct.statebar;
  fg=_WConfig.unsel_lvbfg;
  bg=_WConfig.unsel_lvbbg;
  lvb->fg_normal=fg;
  lvb->bg_normal=bg;
  _freesafe(statebar->text);
  statebar->text=(char*)_allocsafe(1);
  statebar->text[0]=0;
  lvc=mainstruct.lister[nr].lv->first;
  while(lvc!=NULL) {
    if(lvc->active==TRUE) {
      lvc->active=FALSE;
      break;
    }
    lvc=lvc->next;
  }
  _RedrawWin(mainwin);
}

void _NL_Shutdown()
{
  _RealLister *rl;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;  
  if(rl->FEDir[0]!=NULL) {
    _FreeDir(rl->FEDir[0]);
    _freesafe(rl->Dir[0]);
  }
  if(rl->FEDir[1]!=NULL) {
    _FreeDir(rl->FEDir[1]);
    _freesafe(rl->Dir[1]);
  }
  _freesafe(rl);
  mainstruct.mode_info[0].special_info=NULL;
}

void _NL_RebuildLister(int nr)
{
  /* Baut LVCs neu auf, berprft dabei auch den Filter */
  _RealLister *rl;
  _ListView *lv;
  _FileEntry *first,*fe,*fe2;
  _ListViewContent *lvc,*last;
  _StringGadget *path;
  int maxlen,lvcnr,fenr;
  int dirnr[2],filenr[2],selbytes;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  lv=mainstruct.lister[nr].lv;
  path=mainstruct.lister[nr].path;
  
  first=rl->FEDir[nr];
  if(first!=NULL) {
    if(mainstruct.lister[nr].filter_changed==TRUE) {
      _NL_CheckFilterAll(nr);
    }
    if(mainstruct.lister[nr].sortmode!=rl->act_sortmode[nr]) {
      /* ReSort */
      first=_SortDir(first,mainstruct.lister[nr].sortmode);
      rl->act_sortmode[nr]=mainstruct.lister[nr].sortmode;
    }
    strcpy(path->string,rl->Dir[nr]);
    if(path->cursor>strlen(rl->Dir[nr])) path->cursor=strlen(rl->Dir[nr]);
    if(path->startpos>strlen(rl->Dir[nr])) path->startpos=strlen(rl->Dir[nr]);
    lvc=lv->first;
    lvcnr=0;
    while(lvc!=NULL) {
      lvcnr++;
      lvc=lvc->next;
    }
    fe=first;
    fe2=first;
    maxlen=0;
    fenr=0;
    while(fe2!=NULL) {
      if(fe2->infilter==TRUE) {
        if(strlen(fe2->name)>maxlen) maxlen=strlen(fe2->name);
        fenr++;
      }
      fe2=fe2->next;
    }
    fe->maxlen=maxlen;
    if(fenr!=lvcnr) {
      /* es gibt mehr oder weniger LVC als FE => anpassen */
      if(lvcnr>fenr) {
        lvc=lv->first;
        while(lvcnr>fenr) {
          _RemoveListViewContent(mainwin,lv,lvc);
          lvc=lv->first;
          lvcnr--;
        }
      } else {
        last=lv->first;
        if(last!=NULL) {
          while(last->next!=NULL) last=last->next;
        }
        while(lvcnr<fenr) {
          last=_AddListViewContent(lv,last,"",-1);
          lvcnr++;
        }
      }
      /* angepat */
    }
    last=lv->first;
    dirnr[0]=0;
    dirnr[1]=0;
    filenr[0]=0;
    filenr[1]=0;
    selbytes=0;
    while(fe!=NULL) {
      if(fe->infilter==TRUE) {
        _BuildLVC(fe,last,nr);
        last=last->next;
        if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
          if(fe->select==TRUE) dirnr[0]++;
          dirnr[1]++;
        } else {
          if(fe->islink==TRUE) {
            if(fe->select==TRUE) selbytes+=fe->lsize;
          } else {
            if(fe->select==TRUE) selbytes+=fe->size;
          }
          if(fe->select==TRUE) filenr[0]++;
          filenr[1]++;
        }
      } else {
        if(fe==rl->activefe[nr]) rl->activefe[nr]=NULL;
      }
      fe=fe->next;
    }
    rl->dirnr[nr][0]=dirnr[0];
    rl->dirnr[nr][1]=dirnr[1];
    rl->filenr[nr][0]=filenr[0];
    rl->filenr[nr][1]=filenr[1];
    rl->selbytes[nr]=selbytes;
  }
  if(nr==mainstruct._ActiveLV) _NL_UpdateStatebar();
  _RedrawWin(mainwin);
}

void _NL_Home(int pointerinfo,void *info)
{
  _RealLister *rl;
  _ListView *lv;
  _ListViewContent *lvc;
  _FileEntry *fe;
  int x;
  int nr;

  if(pointerinfo==PISNUMBER) {
    nr=*(int*)info;
  } else {
    nr=mainstruct._ActiveLV;
  }
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  lv=mainstruct.lister[nr].lv;
  if(rl->FEDir[nr]==NULL) return;
  fe=rl->activefe[nr];
  if(fe!=NULL) {
    x=fe->nr;
    lvc=lv->first;
    while(lvc->data!=x) {
      lvc=lvc->next;
    }
    lvc->active=FALSE;
  }
  rl->activefe[nr]=rl->FEDir[nr];
  lv->first->active=TRUE;
    if(lv->vbar_startpos>0) {
    lv->vbar_startpos=0;
    lv->topcontent=lv->first;
  }
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
}

void _NL_End(int pointerinfo,void *info)
{
  int x,maxdisplayv,effheight,entry;
  _RealLister *rl;
  _ListView *lv;
  _ListViewContent *lvc;
  _FileEntry *fe;
  int nr;

  if(pointerinfo==PISNUMBER) {
    nr=*(int*)info;
  } else {
    nr=mainstruct._ActiveLV;
  }

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  lv=mainstruct.lister[nr].lv;

  if(rl->FEDir[nr]==NULL) return;
  fe=rl->activefe[nr];
  lvc=lv->first;
  entry=0;
  if(fe!=NULL) {
    while(lvc->data!=fe->nr) {
      lvc=lvc->next;
      entry++;
    }
    lvc->active=FALSE;
  } else {
    fe=rl->FEDir[nr];
  }
  while(lvc->next!=NULL) {
    lvc=lvc->next;
    entry++;
  }
  while(lvc->data!=fe->nr) {
    fe=fe->next;
  }
  rl->activefe[nr]=fe;
  lvc->active=TRUE;
  x=entry-lv->vbar_startpos+1;
  effheight=lv->height-4-lv->hbar_height;
  maxdisplayv=_MaxDisplayV(mainwin,effheight);
  while(x>maxdisplayv) {
    lv->vbar_startpos++;
    lv->topcontent=lv->topcontent->next;
    x=entry-lv->vbar_startpos+1;
  }
  while(x<1) {
    lv->vbar_startpos--;
    lv->topcontent=lv->topcontent->prev;
    x=entry-lv->vbar_startpos+1;
  }
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
}

void _NL_Down(int pointerinfo,void *info)
{
  int x,maxdisplayv,effheight,entry;
  _RealLister *rl;
  _ListView *lv;
  _ListViewContent *lvc;
  _FileEntry *fe;
  int nr;

  if(pointerinfo==PISNUMBER) {
    nr=*(int*)info;
  } else {
    nr=mainstruct._ActiveLV;
  }

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  lv=mainstruct.lister[nr].lv;
  fe=rl->FEDir[nr];
  if(fe==NULL) return;
  if(rl->activefe[nr]==NULL) {
    rl->activefe[nr]=fe;
    lvc=lv->first;
    lvc->active=TRUE;
    if(lv->vbar_startpos>0) {
      lv->vbar_startpos=0;
      lv->topcontent=lv->first;
    }
  } else {
    fe=rl->activefe[nr];
    x=fe->nr;
    lvc=lv->first;
    entry=0;
    while(lvc->data!=x) {
      lvc=lvc->next;  /* da fe gerade aktiv muss es als LVC exist. */
      entry++;
    }
    if(lvc->next!=NULL) {
      lvc->active=FALSE;
      lvc=lvc->next;
      entry++;
      lvc->active=TRUE;
      fe=fe->next;
      while(fe->infilter!=TRUE) fe=fe->next;
      rl->activefe[nr]=fe;
      x=entry-lv->vbar_startpos+1;
      effheight=lv->height-4-lv->hbar_height;
      maxdisplayv=_MaxDisplayV(mainwin,effheight);
      while(x>maxdisplayv) {
        lv->vbar_startpos++;
        lv->topcontent=lv->topcontent->next;
        x=entry-lv->vbar_startpos+1;
      }
      while(x<1) {
        lv->vbar_startpos--;
        lv->topcontent=lv->topcontent->prev;
        x=entry-lv->vbar_startpos+1;
      }
    }
  }
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
}

void _NL_Up(int pointerinfo,void *info)
{
  int x,maxdisplayv,effheight,entry;
  _RealLister *rl;
  _ListView *lv;
  _ListViewContent *lvc;
  _FileEntry *fe;
  int nr;

  if(pointerinfo==PISNUMBER) {
    nr=*(int*)info;
  } else {
    nr=mainstruct._ActiveLV;
  }
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  lv=mainstruct.lister[nr].lv;
  fe=rl->FEDir[nr];
  if(fe==NULL) return;
  if(rl->activefe[nr]==NULL) {
    rl->activefe[nr]=fe;
    lvc=lv->first;
    lvc->active=TRUE;
    if(lv->vbar_startpos>0) {
      lv->vbar_startpos=0;
      lv->topcontent=lv->first;
    }
  } else {
    fe=rl->activefe[nr];
    x=fe->nr;
    lvc=lv->first;
    entry=0;
    while(lvc->data!=x) {
      lvc=lvc->next;  /* da fe gerade aktiv muss es als LVC exist. */
      entry++;
    }
    if(lvc->prev!=NULL) {
      lvc->active=FALSE;
      lvc=lvc->prev;
      entry--;
      lvc->active=TRUE;
      fe=fe->prev;
      while(fe->infilter!=TRUE) fe=fe->prev;
      rl->activefe[nr]=fe;
      x=entry-lv->vbar_startpos+1;
      effheight=lv->height-4-lv->hbar_height;
      maxdisplayv=_MaxDisplayV(mainwin,effheight);
      while(x>maxdisplayv) {
        lv->vbar_startpos++;
        lv->topcontent=lv->topcontent->next;
        x=entry-lv->vbar_startpos+1;
      }
      while(x<1) {
        lv->vbar_startpos--;
        lv->topcontent=lv->topcontent->prev;
        x=entry-lv->vbar_startpos+1;
      }
    }
  }
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
}

void _NL_Left(int pointerinfo,void *info)
{
  _RealLister *rl;
  int nr;

  if(pointerinfo==PISNUMBER) {
    nr=*(int*)info;
  } else {
    nr=mainstruct._ActiveLV;
  }
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  if(rl->FEDir[nr]==NULL) return;
  if(S_ISDIR(rl->FEDir[nr]->mode)) {
    _NL_GoDir(rl->FEDir[nr],NULL);
  }
}

void _NL_Right(int pointerinfo,void *info)
{
  _RealLister *rl;
  int nr;

  if(pointerinfo==PISNUMBER) {
    nr=*(int*)info;
  } else {
    nr=mainstruct._ActiveLV;
  }
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  if(rl->activefe[nr]==NULL) return;
  if(S_ISDIR(rl->activefe[nr]->mode)) {
    _NL_GoDir(rl->activefe[nr],NULL);
  }
}

void _NL_PageDown(int pointerinfo,void *info)
{
  int x,maxdisplayv,effheight,entry,elems;
  _RealLister *rl;
  _ListView *lv;
  _ListViewContent *lvc;
  _FileEntry *fe;
  int nr;

  if(pointerinfo==PISNUMBER) {
    nr=*(int*)info;
  } else {
    nr=mainstruct._ActiveLV;
  }
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  lv=mainstruct.lister[nr].lv;
  if(rl->FEDir[nr]==NULL) return;
  if(rl->activefe[nr]==NULL) {
    rl->activefe[nr]=rl->FEDir[nr];
    lv->first->active=TRUE;
    if(lv->vbar_startpos>0) {
      lv->vbar_startpos=0;
      lv->topcontent=lv->first;
    }
  } else {
    fe=rl->activefe[nr];
    if(fe->next!=NULL) {
      lvc=lv->first;
      entry=0;
      while(lvc->data!=fe->nr) {
        lvc=lvc->next;
        entry++;
      }
      lvc->active=FALSE;
      effheight=lv->height-4-lv->hbar_height;
      maxdisplayv=_MaxDisplayV(mainwin,effheight);
      elems=maxdisplayv-1;
      for(x=0;x<elems;x++) {
        if(lvc->next!=NULL) {
          lvc=lvc->next;
          entry++;
        }
      }
      while(lvc->data!=fe->nr) {
        fe=fe->next;
      }      
      lvc->active=TRUE;
      rl->activefe[nr]=fe;
      x=entry-lv->vbar_startpos+1;
      while(x>maxdisplayv) {
        lv->vbar_startpos++;
        lv->topcontent=lv->topcontent->next;
        x=entry-lv->vbar_startpos+1;
      }
      while(x<1) {
        lv->vbar_startpos--;
        lv->topcontent=lv->topcontent->prev;
        x=entry-lv->vbar_startpos+1;
      }
    }
  }
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
}

void _NL_PageUp(int pointerinfo,void *info)
{
  _RealLister *rl;
  _ListView *lv;
  _ListViewContent *lvc;
  _FileEntry *fe;
  int x,maxdisplayv,effheight,entry,elems;
  int nr;

  if(pointerinfo==PISNUMBER) {
    nr=*(int*)info;
  } else {
    nr=mainstruct._ActiveLV;
  }

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  lv=mainstruct.lister[nr].lv;
  if(rl->FEDir[nr]==NULL) return;
  if(rl->activefe[nr]==NULL) {
    rl->activefe[nr]=rl->FEDir[nr];
    lv->first->active=TRUE;
    if(lv->vbar_startpos>0) {
      lv->vbar_startpos=0;
      lv->topcontent=lv->first;
    }
  } else {
    fe=rl->activefe[nr];
    if(fe->prev!=NULL) {
      lvc=lv->first;
      entry=0;
      while(lvc->data!=fe->nr) {
        lvc=lvc->next;
        entry++;
      }
      lvc->active=FALSE;
      effheight=lv->height-4-lv->hbar_height;
      maxdisplayv=_MaxDisplayV(mainwin,effheight);
      elems=maxdisplayv-1;
      for(x=0;x<elems;x++) {
        if(lvc->prev!=NULL) {
          lvc=lvc->prev;
          entry--;
        }
      }
      while(lvc->data!=fe->nr) {
        fe=fe->prev;
      }
      lvc->active=TRUE;
      rl->activefe[nr]=fe;      
      x=entry-lv->vbar_startpos+1;
      while(x>maxdisplayv) {
        lv->vbar_startpos++;
        lv->topcontent=lv->topcontent->next;
        x=entry-lv->vbar_startpos+1;
      }
      while(x<1) {
        lv->vbar_startpos--;
        lv->topcontent=lv->topcontent->prev;
        x=entry-lv->vbar_startpos+1;
      }
    }
  }
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
}

void _NL_SelectActive(int pointerinfo,void *info)
{
  _RealLister *rl;
  _ListView *lv;
  _ListViewContent *lvc;
  _FileEntry *fe;
  bool oldstate;
  int nr;

  if(pointerinfo==PISNUMBER) {
    nr=*(int*)info;
  } else {
    nr=mainstruct._ActiveLV;
  }
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  lv=mainstruct.lister[nr].lv;

  fe=rl->activefe[nr];
  if(fe==NULL) return;
  lvc=lv->first;
  while(lvc->data!=fe->nr) {
    lvc=lvc->next;
  }
  oldstate=lvc->select;
  if(oldstate==FALSE) {
    lvc->select=TRUE;
  } else {
    lvc->select=FALSE;
  }
  _NL_SelectProc(lv,lvc);
  _NL_Down(PISNUMBER,&nr);
}

void _ParseActive(void)
{
/*  int x,maxdisplayv,effheight,entry;
  if(_FEDir[_ActiveLV]==NULL) return;
  if(activefe[_ActiveLV]!=NULL) {
    activelvc[_ActiveLV]->active=TRUE;
    entry=activelvc[_ActiveLV]->data;
    x=entry-lv[_ActiveLV]->vbar_startpos+1;
    effheight=lv[_ActiveLV]->height-4-lv[_ActiveLV]->hbar_height;
    maxdisplayv=_MaxDisplayV(mainwin,effheight);
    while(x>maxdisplayv) {
      lv[_ActiveLV]->vbar_startpos++;
      lv[_ActiveLV]->topcontent=lv[_ActiveLV]->topcontent->next;
      x=entry-lv[_ActiveLV]->vbar_startpos+1;
    }
    while(x<1) {
      lv[_ActiveLV]->vbar_startpos--;
      lv[_ActiveLV]->topcontent=lv[_ActiveLV]->topcontent->prev;
      x=entry-lv[_ActiveLV]->vbar_startpos+1;
    }
    _GUIDrawListView(mainwin,lv[_ActiveLV],LV_NORMAL,BUFFER);
    _FlushWin(mainwin,lv[_ActiveLV]->x,lv[_ActiveLV]->y,lv[_ActiveLV]->width,lv[_ActiveLV]->height);
  }*/
}

void _NL_UpdateStatebar(void)
{
  char *tstr,buf[3],tbuffer[15];
  int x,y,lister;
  _RealLister *rl;
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  lister=mainstruct._ActiveLV;
  tstr=(char*)_allocsafe(strlen(_locale[107])+strlen(_locale[108])+100);
  x=rl->selbytes[lister];
  MakeLong2NiceStr(tbuffer,x);
  y=0;
  if(x>(1024*1024*10)) {
    y=1;
    x/=1024*1024;
    strcpy(buf,"MB");
  } else if(x>(1024*1024)) {
    y=1;
    x/=1024;
    strcpy(buf,"KB");
  }
  _freesafe(mainstruct.statebar->text);
  mainstruct.statebar->text=tstr;
  if(y==1) {
//    sprintf(tstr,"%s:%ld/%ld %s:%ld/%ld %s:%ld | %d %s",_locale[107],rl->filenr[lister][0],rl->filenr[lister][1],_locale[108],rl->dirnr[lister][0],rl->dirnr[lister][1],_locale[13],rl->selbytes[lister],x,buf);
    sprintf(tstr,"%s:%ld/%ld %s:%ld/%ld %s:%s | %d %s",_locale[107],rl->filenr[lister][0],rl->filenr[lister][1],_locale[108],rl->dirnr[lister][0],rl->dirnr[lister][1],_locale[13],tbuffer,x,buf);
  } else {
//    sprintf(tstr,"%s:%ld/%ld %s:%ld/%ld %s:%ld",_locale[107],rl->filenr[lister][0],rl->filenr[lister][1],_locale[108],rl->dirnr[lister][0],rl->dirnr[lister][1],_locale[13],rl->selbytes[lister]);
    sprintf(tstr,"%s:%ld/%ld %s:%ld/%ld %s:%s",_locale[107],rl->filenr[lister][0],rl->filenr[lister][1],_locale[108],rl->dirnr[lister][0],rl->dirnr[lister][1],_locale[13],tbuffer);
  }
  _GUIDrawSolidButton(mainwin,mainstruct.statebar,BUFFER);
  _FlushWin(mainwin,mainstruct.statebar->x,mainstruct.statebar->y,mainstruct.statebar->width,mainstruct.statebar->height);
}

int _NL_SetDir(const char *pathstr,int nr)
{
  /* Rckgabewert: 0 wenn alles ok
                   1 wenn _ReadDir fehlschlgt */
  char *buffer,*buf2,*tstr;
  _FileEntry *first,*fe;
  _RealLister *rl;
  int returnvalue,entry=0,x,actpos=0;
  int maxdisplayv,effheight;
  _ListViewContent *lvc;
  _ListView *lv=NULL;
  bool samedir;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;

  /* vvv Dies dient zur Erkennung, ob wir das gleiche Verzeichnis nochmal laden
         dann sollte der gleiche Eintrag wieder aktiv sein und das LV an der gleichen
         Position stehen vvv*/
  if(rl->Dir[nr]==NULL) samedir=FALSE;
  else {
    if(strcmp(rl->Dir[nr],pathstr)==0) samedir=TRUE; else samedir=FALSE;
  }
  /* ^^^ Ende Zusatztcode ^^^ */

  returnvalue=0;
  buf2=(char*)_allocsafe(16384);
  buffer=_HandlePath(pathstr);
  first=_ReadDir(buffer);
  if(first!=NULL) {
    first=_SortDir(first,mainstruct.lister[nr].sortmode);
    rl->act_sortmode[nr]=mainstruct.lister[nr].sortmode;
    strcpy(mainstruct.lister[nr].path->string,buffer);
    if(mainstruct.lister[nr].path->cursor>strlen(buffer)) mainstruct.lister[nr].path->cursor=strlen(buffer);
    if(mainstruct.lister[nr].path->startpos>strlen(buffer)) mainstruct.lister[nr].path->startpos=strlen(buffer);
    
    /* vvv Zusatz vvv*/
    if(samedir==TRUE) {
      entry=0;
      lv=mainstruct.lister[nr].lv;
      lvc=lv->first;
      while(lvc!=NULL) {
        if(lvc==lv->topcontent) break;
        lvc=lvc->next;
        entry++;
      }
      actpos=-1;
      if(rl->activefe[nr]!=NULL) {
        fe=rl->FEDir[nr];
        while(fe!=NULL) {
          actpos++;
          if(fe==rl->activefe[nr]) break;
          fe=fe->next;
        }
      }
    }
    /* ^^^ Ende Zusatz ^^^ */
    
    _FreeDir(rl->FEDir[nr]);
    rl->FEDir[nr]=first;
    tstr=(char*)_allocsafe(strlen(buffer)+1);
    if(rl->Dir[nr]!=NULL) _freesafe(rl->Dir[nr]);
    strcpy(tstr,buffer);
    rl->Dir[nr]=tstr;

    rl->filesunchecked=TRUE;
    fe=first;
    while(fe!=NULL) {
      if(!S_ISDIR(fe->mode)) break;
      fe=fe->next;
    }
    rl->nextcheck[nr]=fe;
    rl->activefe[nr]=NULL;

    /* vvv Zusatz vvv*/
    if(samedir==TRUE) {
      fe=first;
      if(actpos>=0) {
        while(actpos>0) {
          actpos--;
          fe=fe->next;
          if(fe==NULL) break;
        }
        rl->activefe[nr]=fe;
      }
    }
    /* ^^^ Ende Zusatz ^^^ */
    
    _NL_RebuildLister(nr);

    /* vvv Zusatz vvv */
    if(samedir==TRUE) {
      effheight=lv->height-4-lv->hbar_height;
      maxdisplayv=_MaxDisplayV(mainwin,effheight);
      x=entry-lv->vbar_startpos+1;
      while(x>maxdisplayv) {
        lv->vbar_startpos++;
        lv->topcontent=lv->topcontent->next;
        x=entry-lv->vbar_startpos+1;
      }
      while(x<1) {
        lv->vbar_startpos--;
        lv->topcontent=lv->topcontent->prev;
        x=entry-lv->vbar_startpos+1;
      }
    }
    /* ^^^ Ende Zusatz ^^^ */

    if(nr==mainstruct._ActiveLV) {
      _NL_UpdateStatebar();
    }
  } else {
    /* Originalwert setzen */
    returnvalue=1;
    if(rl->Dir[nr]!=NULL) {
      strcpy(mainstruct.lister[nr].path->string,rl->Dir[nr]);
      if(mainstruct.lister[nr].path->cursor>strlen(rl->Dir[nr])) mainstruct.lister[nr].path->cursor=strlen(rl->Dir[nr]);
      if(mainstruct.lister[nr].path->startpos>strlen(rl->Dir[nr])) mainstruct.lister[nr].path->startpos=strlen(rl->Dir[nr]);
    }
  }
  _freesafe(buf2);
  _freesafe(buffer);
  _RedrawWin(mainwin);
  return returnvalue;
}

void _BuildLVC(_FileEntry *fe,_ListViewContent *lvc,int nr)
{
  char *buf2,rightsbuf[10],typbuffer[MAX_FILETYPENAMELEN+1],formstr[30];
  char sizebuffer[20];
  int x,maxlen,ts;
  bool exe;
  _RealLister *rl;
  mode_t modus;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  maxlen=rl->FEDir[nr]->maxlen;
  x=strlen(fe->name);
  if(x>maxlen) {
    maxlen=x;
    rl->FEDir[nr]->maxlen=maxlen;
  }
  buf2=(char*)_allocsafe(9+1+12+1+1+maxlen+1+MAX_FILETYPENAMELEN+1);
  strcpy(rightsbuf,"");
  if(fe->filetypeindex==-2) {
    strcpy(typbuffer,_locale[112]);
  } else if(fe->filetypeindex==-1) {
    strcpy(typbuffer,_locale[113]);
  } else {
    if(fe->filetype!=NULL) {
      strcpy(typbuffer,fe->filetype->name);
    } else {
      strcpy(typbuffer,"???");
    }
  }
  exe=FALSE;
  strcpy(rightsbuf,"");
  if(fe->filetypeindex==-2) {
    strcpy(typbuffer,_locale[112]);
  } else if(fe->filetypeindex==-1) {
    strcpy(typbuffer,_locale[113]);
  } else {
    if(fe->filetype!=NULL) {
      strcpy(typbuffer,fe->filetype->name);
    } else {
      strcpy(typbuffer,"???");
    }
  }
  if(fe->islink==TRUE) {
    modus=fe->lmode;
  } else {
    modus=fe->mode;
  }
  if((modus&S_IRUSR)==S_IRUSR) strcat(rightsbuf,"r"); else strcat(rightsbuf,"-");
  if((modus&S_IWUSR)==S_IWUSR) strcat(rightsbuf,"w"); else strcat(rightsbuf,"-");
  if((modus&S_ISUID)==S_ISUID) {
    if((modus&S_IXUSR)==S_IXUSR) {strcat(rightsbuf,"s");exe=TRUE;} else strcat(rightsbuf,"S");
  } else {
    if((modus&S_IXUSR)==S_IXUSR) {strcat(rightsbuf,"x");exe=TRUE;} else strcat(rightsbuf,"-");
  }
  if((modus&S_IRGRP)==S_IRGRP) strcat(rightsbuf,"r"); else strcat(rightsbuf,"-");
  if((modus&S_IWGRP)==S_IWGRP) strcat(rightsbuf,"w"); else strcat(rightsbuf,"-");
  if((modus&S_ISGID)==S_ISGID) {
    if((modus&S_IXGRP)==S_IXGRP) {strcat(rightsbuf,"s");exe=TRUE;} else strcat(rightsbuf,"S");
  } else {
    if((modus&S_IXGRP)==S_IXGRP) {strcat(rightsbuf,"x");exe=TRUE;} else strcat(rightsbuf,"-");
  }
  if((modus&S_IROTH)==S_IROTH) strcat(rightsbuf,"r"); else strcat(rightsbuf,"-");
  if((modus&S_IWOTH)==S_IWOTH) strcat(rightsbuf,"w"); else strcat(rightsbuf,"-");
  if((modus&S_ISVTX)==S_ISVTX) {
    if((modus&S_IXOTH)==S_IXOTH) {strcat(rightsbuf,"t");exe=TRUE;} else strcat(rightsbuf,"T");
  } else {
    if((modus&S_IXOTH)==S_IXOTH) {strcat(rightsbuf,"x");exe=TRUE;} else strcat(rightsbuf,"-");
  }
  if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
    if(fe->islink==TRUE) {
/*      sprintf(formstr,"%%9s %%-10d ~%%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);*/
      sprintf(formstr,"%%9s %%-12s ~%%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);
      if(fe->dirsize>=0) ts=fe->dirsize; else ts=fe->lsize;
      MakeLong2NiceStr(&sizebuffer[0],ts);
/*      sprintf(buf2,formstr,rightsbuf,ts,fe->name,_locale[110]);*/
      sprintf(buf2,formstr,rightsbuf,sizebuffer,fe->name,_locale[110]);
    } else {
/*      sprintf(formstr,"%%9s %%-10d /%%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);*/
      sprintf(formstr,"%%9s %%-12s /%%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);
      if(fe->dirsize>=0) ts=fe->dirsize; else ts=fe->size;
      MakeLong2NiceStr(&sizebuffer[0],ts);
/*      sprintf(buf2,formstr,rightsbuf,ts,fe->name,_locale[109]);*/
      sprintf(buf2,formstr,rightsbuf,sizebuffer,fe->name,_locale[109]);
    }
  } else {
    if(fe->islink==TRUE) {
      if(fe->iscorrupt==FALSE) {
//        sprintf(formstr,"%%9s %%-10d @%%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);
        sprintf(formstr,"%%9s %%-12s @%%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);
      } else {
//        sprintf(formstr,"%%9s %%-10d !%%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);
        sprintf(formstr,"%%9s %%-12s !%%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);
      }
      MakeLong2NiceStr(&sizebuffer[0],fe->lsize);
//      sprintf(buf2,formstr,rightsbuf,fe->lsize,fe->name,_locale[111]);
      sprintf(buf2,formstr,rightsbuf,sizebuffer,fe->name,_locale[111]);
    } else {
      MakeLong2NiceStr(&sizebuffer[0],fe->size);
      if(exe==FALSE) {
//        sprintf(formstr,"%%9s %%-10d  %%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);
        sprintf(formstr,"%%9s %%-12s  %%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);
//        sprintf(buf2,formstr,rightsbuf,fe->size,fe->name,typbuffer);
        sprintf(buf2,formstr,rightsbuf,sizebuffer,fe->name,typbuffer);
      } else {
//        sprintf(formstr,"%%9s %%-10d *%%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);
        sprintf(formstr,"%%9s %%-12s *%%-%ds %%-%ds",maxlen,MAX_FILETYPENAMELEN);
        sprintf(buf2,formstr,rightsbuf,sizebuffer,fe->name,typbuffer);
      }
    }
  }
  if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
    lvc->fg_normal=_WConfig.unsel_dirfg;
    lvc->bg_normal=_WConfig.unsel_dirbg;
    lvc->fg_select=_WConfig.sel_dirfg;
    lvc->bg_select=_WConfig.sel_dirbg;
  } else {
    lvc->fg_normal=_WConfig.unsel_filefg;
    lvc->bg_normal=_WConfig.unsel_filebg;
    lvc->fg_select=_WConfig.sel_filefg;
    lvc->bg_select=_WConfig.sel_filebg;
  }
  lvc->fg_active=1;
  lvc->bg_active=7;
  lvc->fg_sel_act=2;
  lvc->bg_sel_act=7;
  lvc->data=fe->nr;
  if(fe->iscorrupt==TRUE) {
    lvc->fg_normal=4;
    lvc->fg_active=4;
  }
  if(fe->select==TRUE) lvc->select=TRUE; else lvc->select=FALSE;
  if((fe==rl->activefe[nr])&&(nr==mainstruct._ActiveLV)) lvc->active=TRUE; else lvc->active=FALSE;
  if(strlen(buf2)>mainstruct.lister[nr].lv->maxlength) mainstruct.lister[nr].lv->maxlength=strlen(buf2);
  _freesafe(lvc->text);
  lvc->text=buf2;
}

void _NL_UpdateDir(int pointerinfo,void *info)
{
  _RealLister *rl;
  int nr;

  if(pointerinfo==PISNUMBER) {
    nr=*(int*)info;
  } else {
    nr=mainstruct._ActiveLV;
  }
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  if(rl->Dir[nr]!=NULL) {
    if(strlen(rl->Dir[nr])>0) {
      _NL_SetDir(rl->Dir[nr],nr);
    }
  }
}

int _NL_SelectProc(_ListView *lv,_ListViewContent *lvc)
{
  int nr,x;
  _RealLister *rl;
  _FileEntry *fe;
  _SolidButton *statebar;
  _ListViewContent *oldlvc;
  bool oldstate;
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  
  nr=lv->data-3;
  oldlvc=lv->first;
  fe=rl->activefe[nr];
  if(fe!=NULL) {
    while(oldlvc->data!=fe->nr) {
      oldlvc=oldlvc->next;
    }
    oldlvc->active=FALSE;
  }
  x=lvc->data;
  fe=rl->FEDir[nr];
  while(fe->nr!=lvc->data) {
    fe=fe->next;
  }
  oldstate=fe->select;
  fe->select=lvc->select;
  rl->activefe[nr]=fe;
  lvc->active=TRUE;
  if(oldstate!=fe->select) {
    if(oldstate==TRUE) {
      if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
        rl->dirnr[nr][0]--;
        if(fe->dirsize>=0) rl->selbytes[nr]-=fe->dirsize;
      } else {
        rl->filenr[nr][0]--;
        if(fe->islink==TRUE) {
          rl->selbytes[nr]-=fe->lsize;
        } else {
          rl->selbytes[nr]-=fe->size;
        }
      }
    } else {
      if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
        rl->dirnr[nr][0]++;
        if(fe->dirsize>=0) rl->selbytes[nr]+=fe->dirsize;
      } else {
        rl->filenr[nr][0]++;
        if(fe->islink==TRUE) {
          rl->selbytes[nr]+=fe->lsize;
        } else {
          rl->selbytes[nr]+=fe->size;
        }
      }
    }
  }
  _NL_UpdateStatebar();
  statebar=mainstruct.statebar;
  _GUIDrawSolidButton(mainwin,statebar,BUFFER);
  _FlushWin(mainwin,statebar->x,statebar->y,statebar->width,statebar->height);
  return 0;
}

bool _NL_Check4Exe(_FileEntry *fe)
{
  bool returnvalue;
  returnvalue=FALSE;
  if((fe->mode&S_IXUSR)==S_IXUSR) returnvalue=TRUE;
  if((fe->mode&S_IXGRP)==S_IXGRP) returnvalue=TRUE;
  if((fe->mode&S_IXOTH)==S_IXOTH) returnvalue=TRUE;
  return returnvalue;
}

void _NL_CheckAction(_ListViewContent *lvc)
{
  int nr,x;
  _FileEntry *fe;
  _RealLister *rl;
  struct _filetypedef *ft;
  bool exe;
  void (*prog)(int,void *);

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  x=lvc->data;
  fe=rl->FEDir[nr];
  while(fe->nr!=x) fe=fe->next;
  if(S_ISDIR(fe->mode)) {
    _NL_GoDir(fe,NULL);
  } else {
    exe=_NL_Check4Exe(fe);
    if(exe==TRUE) {
      _NL_RunProgram(PISNOTHING,NULL);
    } else {
      if(fe->filetypeindex>=0) {
        ft=fe->filetype;
        if(ft!=NULL) {
          prog=mainstruct.mode_info[0].prog[ft->comnr];
          if(prog!=NULL) (prog)(PISFILETYPE,ft);
        }
      }
    }
  }
}

void _NL_GoDir(_FileEntry *fe,char *dirnamereturn)
{
  char *tstr;
  char buffer[1024],*tstr2;
  _FileEntry *fe2;
  _ListViewContent *lvc;
  _ListView *lv;
  int nr;
  int x,maxdisplayv,effheight,entry;
  int rv;
  _RealLister *rl;
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  lv=mainstruct.lister[nr].lv;
  strcpy(buffer,"");
  if(dirnamereturn!=NULL) strcpy(dirnamereturn,"");
  if(fe==rl->FEDir[nr]) {
    tstr2=_Parent(rl->Dir[nr],buffer);
    if(dirnamereturn!=NULL) strcpy(dirnamereturn,buffer);
    _freesafe(tstr2);
    if(strlen(rl->Dir[nr])<2) return;
  }
  tstr=(char*)_allocsafe(strlen(rl->Dir[nr])+1+strlen(fe->name)+1);
  strcpy(tstr,rl->Dir[nr]);
  strcat(tstr,"/");
  strcat(tstr,fe->name);
  rv=_NL_SetDir(tstr,nr);
  _freesafe(tstr);
  if(rv==1) return;  /* hier knnen eventl. Fehler von _NL_SetDir angefangen werden
                        speziell im M. jedoch nur der Fehler vom fehlges. ReadDir */
  if(strlen(buffer)>0) {
    /* Parent */
    fe2=rl->FEDir[nr];
    entry=0;
    lvc=mainstruct.lister[nr].lv->first;
    while(fe2!=NULL) {
      if((strcmp(fe2->name,buffer)==0)&&(fe2->infilter==TRUE)) break;
      fe2=fe2->next;
    }
    if(fe2!=NULL) {
      while(lvc->data!=fe2->nr) {
        lvc=lvc->next;
        entry++;
      }
      lvc->active=TRUE;
      rl->activefe[nr]=fe2;
    }
  } else {
    fe2=rl->FEDir[nr];
    entry=0;
    lvc=mainstruct.lister[nr].lv->first;
    if(fe2!=NULL) {
      lvc->active=TRUE;
      rl->activefe[nr]=fe2;
    }
  }
  x=entry-lv->vbar_startpos+1;
  effheight=lv->height-4-lv->hbar_height;
  maxdisplayv=_MaxDisplayV(mainwin,effheight);
  while(x>maxdisplayv) {
    lv->vbar_startpos++;
    lv->topcontent=lv->topcontent->next;
    x=entry-lv->vbar_startpos+1;
  }
  while(x<1) {
    lv->vbar_startpos--;
    lv->topcontent=lv->topcontent->prev;
    x=entry-lv->vbar_startpos+1;
  }
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
}

void _NL_CheckFilterAll(int nr)
{
  _RealLister *rl;
  _FileEntry *fe;
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  fe=rl->FEDir[nr];
  while(fe!=NULL) {
    if(!S_ISDIR(fe->mode)) fe->infilter=_CheckFilter(fe->name,nr);
    else fe->infilter=TRUE;
    fe=fe->next;
  }
}

void _NL_SelectAllOp(int pointerinfo,void *info)
{
  _FileEntry *fe;
  _ListViewContent *lvc;
  _ListView *lv;
  _RealLister *rl;
  struct _solidbutton *statebar;
  int anr;
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  statebar=mainstruct.statebar;
  anr=mainstruct._ActiveLV;
  lv=mainstruct.lister[anr].lv;
  lvc=lv->first;
  fe=rl->FEDir[anr];
  rl->selbytes[anr]=0;
  while(lvc!=NULL) {
    lvc->select=TRUE;
    fe->select=TRUE;
    if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
      if(fe->dirsize>=0) rl->selbytes[anr]+=fe->dirsize;
    } else {
      if(fe->islink==TRUE) {
        rl->selbytes[anr]+=fe->lsize;
      } else {
        rl->selbytes[anr]+=fe->size;
      }
    }
    do {
      fe=fe->next;
      if(fe==NULL) break;
    } while((fe->infilter==FALSE)&&(fe!=NULL));
    lvc=lvc->next;
  }
  rl->dirnr[anr][0]=rl->dirnr[anr][1]; 
  rl->filenr[anr][0]=rl->filenr[anr][1];
  _NL_UpdateStatebar();
  _GUIDrawSolidButton(mainwin,statebar,BUFFER);
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
  _FlushWin(mainwin,statebar->x,statebar->y,statebar->width,statebar->height);
}

void _NL_SelectNoneOp(int pointerinfo,void *info)
{
  _FileEntry *fe;
  _ListViewContent *lvc;
  _ListView *lv;
  _RealLister *rl;
  struct _solidbutton *statebar;
  int anr;
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  statebar=mainstruct.statebar;
  anr=mainstruct._ActiveLV;
  lv=mainstruct.lister[anr].lv;
  lvc=lv->first;
  fe=rl->FEDir[anr];
  rl->selbytes[anr]=0;
  while(lvc!=NULL) {
    lvc->select=FALSE;
    fe->select=FALSE;
    do {
      fe=fe->next;
      if(fe==NULL) break;
    } while((fe->infilter==FALSE)&&(fe!=NULL));
    lvc=lvc->next;
  }
  rl->dirnr[anr][0]=0; 
  rl->filenr[anr][0]=0;
  _NL_UpdateStatebar();
  _GUIDrawSolidButton(mainwin,statebar,BUFFER);
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
  _FlushWin(mainwin,statebar->x,statebar->y,statebar->width,statebar->height);
}

void _NL_InvertOp(int pointerinfo,void *info)
{
  _FileEntry *fe;
  _ListViewContent *lvc;
  bool oldstate;
  _ListView *lv;
  _RealLister *rl;
  struct _solidbutton *statebar;
  int nr;
  
  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  statebar=mainstruct.statebar;
  nr=mainstruct._ActiveLV;
  lv=mainstruct.lister[nr].lv;
  lvc=lv->first;
  fe=rl->FEDir[nr];
  while(lvc!=NULL) {
    oldstate=fe->select;
    if(oldstate==TRUE) {
      if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
        rl->dirnr[nr][0]--;
        if(fe->dirsize>=0) rl->selbytes[nr]-=fe->dirsize;
      } else {
        rl->filenr[nr][0]--;
        if(fe->islink==TRUE) {
          rl->selbytes[nr]-=fe->lsize;
        } else {
          rl->selbytes[nr]-=fe->size;
        }
      }
      lvc->select=FALSE;
      fe->select=FALSE;
    } else {
      if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
        rl->dirnr[nr][0]++;
        if(fe->dirsize>=0) rl->selbytes[nr]+=fe->dirsize;
      } else {
        rl->filenr[nr][0]++;
        if(fe->islink==TRUE) {
          rl->selbytes[nr]+=fe->lsize;
        } else {
          rl->selbytes[nr]+=fe->size;
        }
      }
      lvc->select=TRUE;
      fe->select=TRUE;
    }
    do {
      fe=fe->next;
      if(fe==NULL) break;
    } while((fe->infilter==FALSE)&&(fe!=NULL));
    lvc=lvc->next;
  }
  _NL_UpdateStatebar();
  _GUIDrawSolidButton(mainwin,statebar,BUFFER);
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
  _FlushWin(mainwin,statebar->x,statebar->y,statebar->width,statebar->height);
}

void _NL_FreeDirList(_CDirEntry *dir)
{
  _CDirEntry *subdir,*tdir;
  bool rootdir;

  if(dir->parent==NULL) rootdir=TRUE; else rootdir=FALSE;
  /* erst alle Unterverzeichnisse freilassen */
  subdir=dir->sub;
  while(subdir!=NULL) {
    tdir=subdir->right;
    _NL_FreeDirList(subdir);
    subdir=tdir;
  }
  dir->sub=NULL;
  if(dir->dirname!=NULL) _freesafe(dir->dirname);
  if(dir->dirfullname!=NULL) _freesafe(dir->dirfullname);
  if(rootdir==FALSE) _FreeDir(dir->first);
  _freesafe(dir);
}

/*****************************************************
  Copy-Fkt.
  ***************************************************/

char *_GetNewName(char *origname,char *path,bool isDir)
{
  char *newname,*tstr1,*tstr2,*tstr3;
  char *msg1,*infotext[2],*buttontext[2];
  bool nameok;
  struct stat statbuf;
  int error,x;

  newname=NULL;
  tstr1=(char*)_allocsafe(strlen(origname)+1);
  strcpy(tstr1,origname);
  nameok=FALSE;
  while(nameok==FALSE) {
    tstr2=_RequestNewName(tstr1);
    if(tstr2!=NULL) {
        /* neuer vollst. Name */
      tstr3=(char*)_allocsafe(strlen(path)+1+strlen(tstr2)+1);
      strcpy(tstr3,path);
      if(strlen(path)>1) strcat(tstr3,"/");
      strcat(tstr3,tstr2);
        /* Prfen auf Existenz */
      error=stat(tstr3,&statbuf);
      if(error!=0) {
        _freesafe(tstr3);
        _freesafe(tstr1);
        newname=tstr2;
        nameok=TRUE;
      } else {
        if(S_ISDIR(statbuf.st_mode)) {
          if(isDir==TRUE) {
            /* das ist ok: Meldung, das ein Verz. schon ex. und Frage, ob dieses ben. werden
               soll */
            msg1=(char*)_allocsafe(strlen(_locale[190])+strlen(tstr3)+1);
            sprintf(msg1,_locale[190],tstr3);
            infotext[0]=msg1;
            infotext[1]=_locale[192];
            buttontext[0]=_locale[11];
            buttontext[1]=_locale[8];
            x=_Request(_locale[123],2,infotext,2,buttontext);
            _freesafe(infotext[0]);
            if(x!=0) {
              _freesafe(tstr3);
              _freesafe(tstr1);
              tstr1=tstr2;
              nameok=FALSE;
            } else {
              _freesafe(tstr3);
              _freesafe(tstr1);
              newname=tstr2;
              nameok=TRUE;
            }
          } else {
            /* nochmal eingeben */
            msg1=(char*)_allocsafe(strlen(_locale[190])+strlen(tstr3)+1);
            sprintf(msg1,_locale[190],tstr3);
            infotext[0]=msg1;
            infotext[1]=_locale[191];
            buttontext[0]=_locale[11];
            _Request(_locale[124],2,infotext,1,buttontext);
            _freesafe(infotext[0]);
            _freesafe(tstr3);
            _freesafe(tstr1);
            tstr1=tstr2;
            nameok=FALSE;
          }
        } else {
          /* ist eine Datei frage auf Lschen */
          msg1=(char*)_allocsafe(strlen(_locale[133])+strlen(tstr3)+1);
          sprintf(msg1,_locale[133],tstr3);
          infotext[0]=msg1;
          infotext[1]=_locale[134];
          buttontext[0]=_locale[11];
          buttontext[1]=_locale[8];
          x=_Request(_locale[123],2,infotext,2,buttontext);
          _freesafe(infotext[0]);
          if(x!=0) {
            _freesafe(tstr3);
            _freesafe(tstr1);
            tstr1=tstr2;
            nameok=FALSE;
          } else {
            /* Versuch, Datei zu lschen */
            if(remove(tstr3)!=0) {
              /* Fehler beim Lschen */
              msg1=(char*)_allocsafe(strlen(_locale[138])+strlen(tstr3)+1);
              sprintf(msg1,_locale[138],tstr3);
              infotext[0]=msg1;
              _Request(_locale[125],1,infotext,1,&_locale[11]);
              _freesafe(infotext[0]);
              _freesafe(tstr3);
              _freesafe(tstr1);
              tstr1=tstr2;
              nameok=FALSE;
            } else {
              _freesafe(tstr3);
              _freesafe(tstr1);
              newname=tstr2;
              nameok=TRUE;
            }
          }
        }
      }
    } else {
      newname=NULL;
      _freesafe(tstr1);
      nameok=TRUE;
    }
  }
  return newname;
}

void _UpdateCopyWin(_GfxWin *gfxwin,char *infotext[2],float percent,long files,long dirs,unsigned long bytes,float percent2,long secs)
{
  _Text *gtext;
  _SolidButton *gsolidbutton;
  char *tstr,timebuffer[10];
  int w;
  unsigned long by;
  gtext=gfxwin->GUI.text;
  gsolidbutton=gfxwin->GUI.solidbutton;
  _BeginRefresh(gfxwin);
  if(infotext[0]!=NULL) {
    tstr=(char*)_allocsafe(strlen(infotext[0])+1);
    strcpy(tstr,infotext[0]);
    _freesafe(gtext->text);
    gtext->text=tstr;
    _GUIDrawText(gfxwin,gtext,BUFFER);
    _FlushWin(gfxwin,0,gtext->y-_CharHeight,gfxwin->width,_NBH);
  }
  gtext=gtext->next;
  if(infotext[1]!=NULL) {
    tstr=(char*)_allocsafe(strlen(infotext[1])+1);
    strcpy(tstr,infotext[1]);
    _freesafe(gtext->text);
    gtext->text=tstr;
    _GUIDrawText(gfxwin,gtext,BUFFER);
    _FlushWin(gfxwin,0,gtext->y-_CharHeight,gfxwin->width,_NBH);
  }
  w=gfxwin->width-20;
  w*=percent/100;
  if(w!=gsolidbutton->width) {
    gsolidbutton->width=w;
    tstr=(char*)_allocsafe(50);
    sprintf(tstr,"%3.4g %%",percent);
    _freesafe(gsolidbutton->text);
    gsolidbutton->text=tstr;
    _GUIDrawSolidButton(gfxwin,gsolidbutton,BUFFER);
    _GUIDrawBevelBox(gfxwin,gfxwin->GUI.bevelbox,BUFFER);
    _FlushWin(gfxwin,0,gsolidbutton->y,gfxwin->width,gsolidbutton->height);
  }
  gtext=gtext->next;
  if(files>=0) {
    tstr=(char*)_allocsafe(strlen(_locale[118])+1+50+1);
    sprintf(tstr,"%s %ld",_locale[118],files);
    _freesafe(gtext->text);
    gtext->text=tstr;
    _GUIDrawText(gfxwin,gtext,BUFFER);
    _FlushWin(gfxwin,0,gtext->y-_CharHeight,gfxwin->width,_NBH);
  }
  gtext=gtext->next;
  if(dirs>=0) {
    tstr=(char*)_allocsafe(strlen(_locale[119])+1+50+1);
    sprintf(tstr,"%s %ld",_locale[119],dirs);
    _freesafe(gtext->text);
    gtext->text=tstr;
    _GUIDrawText(gfxwin,gtext,BUFFER);
    _FlushWin(gfxwin,0,gtext->y-_CharHeight,gfxwin->width,_NBH);
  }
  gsolidbutton=gsolidbutton->next;;
  w=gfxwin->width-20;
  w*=percent2/100;
  if(w!=gsolidbutton->width) {
    gsolidbutton->width=w;
    tstr=(char*)_allocsafe(50);
    sprintf(tstr,"%3.4g %%",percent2);
    _freesafe(gsolidbutton->text);
    gsolidbutton->text=tstr;
    _GUIDrawSolidButton(gfxwin,gsolidbutton,BUFFER);
/*    _FlushWin(gfxwin,gsolidbutton->x,gsolidbutton->y,gsolidbutton->width,gsolidbutton->height);*/
    _GUIDrawBevelBox(gfxwin,gfxwin->GUI.bevelbox->next->next,BUFFER);
    _FlushWin(gfxwin,0,gsolidbutton->y,gfxwin->width,gsolidbutton->height);
  }
  gtext=gtext->next;
  tstr=(char*)_allocsafe(strlen(_locale[120])+1+50+1);
  by=bytes;
  strcpy(timebuffer,"");
  if(bytes>(1024*1024*10)) {
    by/=1024*1024;
    strcpy(timebuffer,"MB");
  } else if(bytes>(1024*1024)) {
    by/=1024;
    strcpy(timebuffer,"KB");
  }
  sprintf(tstr,"%s %ld %s",_locale[120],by,timebuffer);
  _freesafe(gtext->text);
  gtext->text=tstr;
  _GUIDrawText(gfxwin,gtext,BUFFER);
  _FlushWin(gfxwin,0,gtext->y-_CharHeight,gfxwin->width,_NBH);
  gtext=gtext->next;
  tstr=(char*)_allocsafe(strlen(_locale[121])+1+50+1);
  if((secs%60)<10) {
    sprintf(timebuffer,"%d:0%ld",(int)(secs/60),secs%60);
  } else {
    sprintf(timebuffer,"%d:%ld",(int)(secs/60),secs%60);
  }
  sprintf(tstr,"%s %s",_locale[121],timebuffer);
  _freesafe(gtext->text);
  gtext->text=tstr;
  _GUIDrawText(gfxwin,gtext,BUFFER);
  _FlushWin(gfxwin,0,gtext->y-_CharHeight,gfxwin->width,_NBH);
}

void _CreateDirLevel(_CDirEntry *rootdir,long flag,unsigned long *filesadr,unsigned long *bytesadr)
{
  _FileEntry *fe1,*fe2;
  _CDirEntry *new,*lastleft;
  char *tstr;
  bool sub,godir;
  unsigned long files,bytes;
  if(rootdir->first==NULL) {
    rootdir->checked=TRUE;
    return;
  }
  if(rootdir->parent!=NULL) sub=TRUE; else sub=FALSE;
  lastleft=NULL;
  files=0;
  bytes=0;
  if(rootdir->first!=NULL) {
    fe1=rootdir->first->next;
    while(fe1!=NULL) {
      if(((fe1->select==TRUE)&&(fe1->infilter))||(sub==TRUE)) {
        if((S_ISDIR(fe1->mode))&&(fe1->iscorrupt==FALSE)) {  
          godir=FALSE;
          if(S_ISLNK(fe1->lmode)) {
            if((flag&1)==1) godir=TRUE;
          } else {
            godir=TRUE;
          }
          if(godir==TRUE) {
            new=(_CDirEntry*)_allocsafe(sizeof(_CDirEntry));
            tstr=(char*)_allocsafe(strlen(fe1->name)+1);
            strcpy(tstr,fe1->name);
            new->parent=rootdir;
            new->sub=NULL;
            new->right=NULL;
            new->left=lastleft;
            new->dirname=tstr;
            tstr=(char*)_allocsafe(strlen(fe1->fullname)+1);
            strcpy(tstr,fe1->fullname);
            new->dirfullname=tstr;
            new->ops_perm=0;
            new->mode=fe1->mode;
            new->checked=FALSE;
            new->error_occ=FALSE;
            fe2=_ReadDir(fe1->fullname);
            fe2=_SortDir(fe2,SORT_NAME);
            new->first=fe2;
            if(lastleft!=NULL) {
              lastleft->right=new;
              lastleft=new;
            } else {
              lastleft=new;
              rootdir->sub=new;
            }
          } else files++;  /* symbolic link wird mitgezhlt */
        } else {
          files++;
          if(fe1->islink==FALSE) {
            if(S_ISREG(fe1->mode)) {
              bytes+=fe1->size;
            }
          }
        }
      }
      fe1=fe1->next;
    }
  }
  rootdir->checked=TRUE;
  *filesadr=files;
  *bytesadr=bytes;
}

int _CopyFile(_FileEntry *fe,char *destfilename,_GfxWin *gfxwin,unsigned long startbytes,unsigned long fullbytes,long files,long dirs,time_t *starttimep,bool *abbruch)
{
  #define BUFFERSIZE 131072
  time_t timep;
  float fa,fb;
  char *infotext[2],*readbuffer;
  unsigned long bytes,fbytes;
  unsigned long nb;
  size_t reads,writes;
  float fper,fper2;
  mode_t newmods;
  int fr,fw;
  int returnvalue;

  returnvalue=0;
  infotext[0]=NULL;
  infotext[1]=NULL;
  fbytes=fe->size;
  bytes=0;
  readbuffer=(char*)_allocsafe(BUFFERSIZE);
  fr=open(fe->fullname,O_RDONLY);
  if(fr!=-1) {
    fw=open(destfilename,O_WRONLY|O_CREAT);
    if(fw!=-1) {
      do {
        reads=read(fr,readbuffer,BUFFERSIZE);
        writes=write(fw,readbuffer,reads);
        if(writes!=reads) break;
        bytes+=writes;
        time(&timep);
        fa=timep-*starttimep;
        nb=startbytes+bytes;
        if(nb==0) fb=0;
        else fb=fa*(fullbytes-nb)/nb;
        if(fullbytes==0) fper2=0;
        else {
          fper2=(float)startbytes+bytes;
          fper2/=(float)fullbytes;
          fper2*=100;
        }
        if(fbytes==0) fper=0;
        else {
          fper=(float)bytes;
          fper/=(float)fbytes;
          fper*=100;
        }
        _UpdateCopyWin(gfxwin,infotext,fper,files,dirs,startbytes+bytes,fper2,(long)fb);
        if(_NL_CheckCancel(gfxwin)==TRUE) *abbruch=TRUE;
      } while((writes==BUFFERSIZE)&&(*abbruch==FALSE));  
      close(fw);
      if(*abbruch==FALSE) {
        newmods=fe->mode&07777;
        chmod(destfilename,newmods);
        chown(destfilename,fe->userid,fe->groupid);
      } else {
        remove(destfilename);
      }
    } else returnvalue=2;
    close(fr);
  } else returnvalue=1;
  _freesafe(readbuffer);
  return returnvalue;
}

void DeSelect(int *entry,int maxdisplayv,_ListView *lv,_ListViewContent **lvc) {
  int x;
  (*lvc)->select=FALSE;
  _NL_SelectProc(lv,*lvc);
  x=(*entry)-lv->vbar_startpos+1;
  while(x>maxdisplayv) {
    lv->vbar_startpos++;
    lv->topcontent=lv->topcontent->next;
    x=(*entry)-lv->vbar_startpos+1;
  }
  while(x<1) {
    lv->vbar_startpos--;
    lv->topcontent=lv->topcontent->prev;
    x=(*entry)-lv->vbar_startpos+1;
  }
  _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
  _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
  while((*lvc)->select==FALSE) {
    (*lvc)=(*lvc)->next;
    (*entry)++;
    if((*lvc)==NULL) break;
  }
}

void _NL_CopyOp(int pointerinfo,void *info)
{
  _ListView *lv;
  _RealLister *rl;
  int nr,onr;
  _ListViewContent *lvc;
  int effheight,maxdisplayv,x,entry;
  int w,h,ty;
  char *tstr;
  bool abbruch,requestpath,takeactive,oldstate=FALSE;
  long flag;
  _CDirEntry *maindir,*tdir1;
  _GfxWin *gfxwin;
  _Message *msg;
  char *destpath;
  int sourcenr;
  unsigned long bytes[2];
  unsigned long files,dirs,byteanz,fileanz;
  time_t starttimep;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  onr=(nr==1)?0:1;
  lv=mainstruct.lister[nr].lv;

  requestpath=FALSE;
  if(rl->FEDir[nr]==NULL) return;
  takeactive=FALSE;
  if((rl->dirnr[nr][0]==0)&&(rl->filenr[nr][0]==0)) {
    if(rl->activefe[nr]==NULL) return;
    else takeactive=TRUE;
  }
  if(mainstruct.lister[onr].activemode!=0) {
    /* anderen Modus */
    requestpath=TRUE;
  }
  if(rl->FEDir[onr]==NULL) requestpath=TRUE;  /* Ziel erfragen */

  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }
  if((flag&16)==16) {
    if(_RequestActionFlags(&flag,COPY)==FALSE) return;
  }
  sourcenr=nr;
  if(requestpath==FALSE) {
    destpath=(char*)_allocsafe(strlen(rl->Dir[onr])+1);
    strcpy(destpath,rl->Dir[onr]);
  } else {
    destpath=StringRequest(rl->Dir[nr],_locale[123],_locale[212]);
    if(destpath==NULL) return;
  }
  bytes[0]=0;
  bytes[1]=0;

  w=mainwin->width*9/10;
  h=5;
  h+=_CharHeight+5;
  h+=_CharHeight+5;
  h+=_BBH+2+5;
  h+=2+5;
  h+=_CharHeight+5;
  h+=_CharHeight+5;
  h+=_CharHeight+5;
  h+=_BBH+2+5;
  h+=_CharHeight+5;
  h+=2+5;
  h+=_BBH+5;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_localecoms[COPY],PMinSize|PMaxSize,NULL);
  if(gfxwin==NULL) {printf("No memory\n");return;}
  ty=5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[122]);
  ty+=_CharHeight+5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,"");
  ty+=_CharHeight+5;
  _CreateBevelBox(gfxwin,9,ty-1,w-18,_BBH+2,HIGH);
  _CreateSolidButton(gfxwin,10,ty,0,_BBH,2,3,"test");
  ty+=_BBH+2+5;
  _CreateBevelBox(gfxwin,5,ty,w-10,2,NORMAL);
  ty+=2+5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[118]);
  ty+=_CharHeight+5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[119]);
  ty+=_CharHeight+5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[120]);
  ty+=_CharHeight+5;
  _CreateBevelBox(gfxwin,9,ty-1,w-18,_BBH+2,HIGH);
  _CreateSolidButton(gfxwin,10,ty,0,_BBH,2,3,"test2");
  ty+=_BBH+2+5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[121]);
  ty+=_CharHeight+5;
  _CreateBevelBox(gfxwin,5,ty,w-10,2,NORMAL);
  ty+=2+5;
  x=strlen(_locale[8])+2;
  x*=_CharWidth;
  _CreateButton(gfxwin,w/2-x/2,ty,x,_BBH,1,0,_locale[8],FALSE,0,0,"",1);
  _RedrawWin(gfxwin);
  XFlush(_GlobalGUI.Dsp);

  if(takeactive==TRUE) {
    oldstate=rl->activefe[nr]->select;
    rl->activefe[nr]->select=TRUE;
  }
  maindir=(_CDirEntry*)_allocsafe(sizeof(_CDirEntry));
  maindir->parent=NULL;
  maindir->left=NULL;
  maindir->right=NULL;
  maindir->sub=NULL;
  maindir->first=rl->FEDir[sourcenr];
  maindir->checked=FALSE;
  maindir->ops_perm=0;
  maindir->error_occ=FALSE;
  tstr=(char*)_allocsafe(1);
  tstr[0]=0;
  maindir->dirname=tstr;
  maindir->dirfullname=NULL;
  /* Erstellung der Database */
  dirs=0;
  files=0;
  _CreateDirLevel(maindir,flag,&fileanz,&byteanz);
  files+=fileanz;
  bytes[1]+=byteanz;
  abbruch=FALSE;
  tdir1=maindir->sub;
  while((tdir1!=NULL)&&(abbruch==FALSE)) {
    if((tdir1->sub==NULL)&&(tdir1->checked==FALSE)) {
      _CreateDirLevel(tdir1,flag,&fileanz,&byteanz);
      files+=fileanz;
      bytes[1]+=byteanz;
      dirs++;
    } else {
      if((tdir1->sub!=NULL)&&(tdir1->sub->checked==FALSE)) {
        tdir1=tdir1->sub;
      } else {
        if((tdir1->sub!=NULL)&&(tdir1->sub->checked==FALSE)) {
          tdir1=tdir1->sub;
        } else if((tdir1->right!=NULL)&&(tdir1->right->checked==FALSE)) {
          tdir1=tdir1->right;
        } else {
          tdir1=tdir1->parent;
        }
      }
    }
    msg=_GetMessage(gfxwin);
    if(msg!=NULL) {
      if(msg->type==ButtonRelease) abbruch=TRUE;
      if(msg->type==KeyRelease) {
        if(msg->key==XK_Escape) abbruch=TRUE;
      }
      _ReplyMessage(msg);
    }
  }
  /* Grundstruktur erstellt */
  /* Struktur durchwandern */

  time(&starttimep);

  effheight=lv->height-4-lv->hbar_height;
  maxdisplayv=_MaxDisplayV(mainwin,effheight);

  tdir1=maindir;
  lvc=lv->first;
  entry=0;
  if(lvc->select==TRUE) {
    lvc->select=FALSE;
    _NL_SelectProc(lv,lvc);
    x=entry-lv->vbar_startpos+1;
    while(x>maxdisplayv) {
      lv->vbar_startpos++;
      lv->topcontent=lv->topcontent->next;
      x=entry-lv->vbar_startpos+1;
    }
    while(x<1) {
      lv->vbar_startpos--;
      lv->topcontent=lv->topcontent->prev;
      x=entry-lv->vbar_startpos+1;
    }
  }
  while(lvc->select==FALSE) {
    if(takeactive==TRUE) {
      if(lvc->active==TRUE) {
        lvc->select=TRUE;
        break;
      }
    }
    lvc=lvc->next;
    entry++;
    if(lvc==NULL) break;
  }
  _NL_RecCopy(maindir,gfxwin,lv,maxdisplayv,destpath,&abbruch,&flag,&files,&dirs,bytes,&starttimep);
  if(takeactive==TRUE) {
    rl->activefe[nr]->select=oldstate;
  }
  _freesafe(destpath);
  /* Database lschen */
  _NL_FreeDirList(maindir);
  _NL_RebuildLister(nr);
  _NL_UpdateDir(PISNUMBER,&onr);
  _CloseWindow(gfxwin);
}

int _NL_CopyNewFile(_FileEntry *fe,char *newpath,_GfxWin *gfxwin,long files,long dirs,long bytes[2],time_t *starttimep)
{
  int x,cerror,returnvalue;
  bool abbruch,opok;
  char buffer[4096],*tstr;
  char *buttontext[5],*infotext[5];
  
  opok=FALSE;
  returnvalue=0;
  abbruch=FALSE;
  if(fe->islink==TRUE) {
    x=readlink(fe->fullname,buffer,4095);
    if(x>=0) {
      buffer[x]=0;
      cerror=symlink(buffer,newpath);
      if(cerror!=0) {
        if(errno==EPERM) {
          /* Hinweis, da das FS keine SymLinks untersttzt */
          tstr=(char*)_allocsafe(strlen(_locale[195])+1);
          sprintf(tstr,"%s",_locale[195]);
          infotext[0]=tstr;
          buttontext[0]=_locale[11];
          buttontext[1]=_locale[8];
          x=_Request(_locale[125],1,infotext,2,buttontext);
          _freesafe(infotext[0]);
          if(x!=0) {
            abbruch=TRUE;
          }
        } else if(errno==EACCES) {
          /* Hinweis, da Op nicht erlaubt */
          tstr=(char*)_allocsafe(strlen(_locale[196])+strlen(newpath)+1);
          sprintf(tstr,_locale[196],newpath);
          infotext[0]=tstr;
          buttontext[0]=_locale[11];
          buttontext[1]=_locale[8];
          x=_Request(_locale[125],1,infotext,2,buttontext);
          if(infotext[0]!=NULL) _freesafe(infotext[0]);
          if(x!=0) {
            abbruch=TRUE;
          }
        }
        returnvalue=returnvalue|4;
      } else opok=TRUE;
    } else returnvalue=returnvalue|2;
  } else {
    /* fe->fullname -> destfilename */
    cerror=_CopyFile(fe,newpath,gfxwin,bytes[0],bytes[1],files,dirs,starttimep,&abbruch);
    if(cerror==2) {
      if(errno==EACCES) {
        tstr=(char*)_allocsafe(strlen(_locale[198])+1);
        sprintf(tstr,_locale[198]);
        infotext[0]=tstr;
        infotext[1]=newpath;
        buttontext[0]=_locale[11];
        buttontext[1]=_locale[8];
        x=_Request(_locale[125],2,infotext,2,buttontext);
        if(infotext[0]!=NULL) _freesafe(infotext[0]);
        if(x!=0) {
          abbruch=TRUE;
        }
      } else if(errno==EROFS) {
        tstr=(char*)_allocsafe(strlen(_locale[194])+1);
        sprintf(tstr,_locale[194]);
        infotext[0]=tstr;
        buttontext[0]=_locale[11];
        buttontext[1]=_locale[8];
        x=_Request(_locale[125],1,infotext,2,buttontext);
        _freesafe(infotext[0]);
        if(x!=0) {
          abbruch=TRUE;
        }
      } else if(errno==ENOSPC) {
        tstr=(char*)_allocsafe(strlen(_locale[197])+1);
        sprintf(tstr,_locale[197]);
        infotext[0]=tstr;
        buttontext[0]=_locale[11];
        buttontext[1]=_locale[8];
        x=_Request(_locale[125],1,infotext,2,buttontext);
        if(infotext[0]!=NULL) _freesafe(infotext[0]);
        if(x!=0) {
          abbruch=TRUE;
        }
      }
      returnvalue=returnvalue|8;
    } else if(cerror==1) {
      /* TODO: Fehlerhandling einbauen */
    } else opok=TRUE;
    bytes[0]+=fe->size;
  }
  if(abbruch==TRUE) returnvalue=returnvalue|1;
  return returnvalue;
  /* Format: Bit 0 abbruch
             Bit 1 SymLink konnte nicht gelesen werden
             Bit 2 SymLink konnte nicht erstellt werden
             Bit 3 Datei konnte nicht kopiert werden */
}

void _NL_DirValues(_CDirEntry *dir,unsigned long *tfiles,unsigned long *tdirs,unsigned long *tbytes)
{
  _CDirEntry *subdir;
  _FileEntry *fe;
  bool takeentry;
  unsigned long stfiles,stdirs,stbytes;
  
  *tfiles=0;
  *tdirs=0;
  *tbytes=0;
  /* erst alle Unterverzeichnisse durchgehen */
  subdir=dir->sub;
  while(subdir!=NULL) {
    (*tdirs)++;
    _NL_DirValues(subdir,&stfiles,&stdirs,&stbytes);
    (*tdirs)+=stdirs;
    (*tfiles)+=stfiles;
    (*tbytes)+=stbytes;
    subdir=subdir->right;
  }
  /* Nun noch alle normalen Dateien */
  fe=dir->first;
  while(fe!=NULL) {
    if(fe->prev!=NULL) {
      if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
        takeentry=FALSE;
      } else {
        takeentry=TRUE;
      }
      if(takeentry==TRUE) {
        (*tfiles)++;
        if(fe->islink==FALSE) {
          (*tbytes)+=fe->size;
        } else {
          (*tbytes)+=fe->lsize;
        }
      }
    }
    fe=fe->next;
  }
}

int _NL_RecCopy(_CDirEntry *tdir,_GfxWin *gfxwin,_ListView *lv,int maxdisplayv,char *destpath,bool *abbruch,long *flag,unsigned long *files,unsigned long *dirs,unsigned long bytes[2],time_t *starttimep)
{
  _CDirEntry *tdir1,*tdir2;
  char *oldpath,*newpath,*newfilename=NULL,*tstr;
  bool rootdir,takenew,overwriteall,overwritenone,makecopy,destexists,overwrite=FALSE;
  bool isdir=FALSE,copyfile,opok,godir,renameflag;
  int returnvalue,error,x;
  _FileEntry *fe;
  char *infotext[10];
  char *buttontext[5];
  struct stat statbuf;
  unsigned long tfiles,tdirs,tbytes;
  _ListViewContent *lvc;
  int entry;

  tdir1=tdir;
  if(tdir1->parent==NULL) rootdir=TRUE; else rootdir=FALSE;
  if(rootdir==TRUE) {
    entry=0;
    lvc=lv->first;
    do {
      lvc=lvc->next;
      entry++;
      if(lvc==NULL) break;
    } while(lvc->select==FALSE);
  }
  fe=tdir1->first->next;
  returnvalue=0;
  if(((*flag)&2)==2) overwriteall=TRUE; else overwriteall=FALSE;
  if(((*flag)&4)==4) overwritenone=TRUE; else overwritenone=FALSE;
  if(((*flag)&8)==8) renameflag=TRUE; else renameflag=FALSE;
  while((fe!=NULL)&&((*abbruch)==FALSE)) {
    for(;fe!=NULL;) {
      if(rootdir==TRUE) {
        if((fe->select==TRUE)&&(fe->infilter==TRUE)) break;
      } else break;
      fe=fe->next;
    }
    if(fe==NULL) break;
    /* fe kopieren -> destpath*/
    opok=FALSE;
    oldpath=fe->fullname;
    takenew=FALSE;
    if(rootdir==TRUE) {
      if(renameflag==TRUE) {
        /* neuen Name erfragen */
        newfilename=_GetNewName(fe->name,destpath,S_ISDIR(fe->mode)?TRUE:FALSE);
        if(newfilename!=NULL) {
          takenew=TRUE;
        } else {
	  takenew=FALSE;
        }
      }
    }
    if(takenew==TRUE) {
      newpath=(char*)_allocsafe(strlen(destpath)+1+strlen(newfilename)+1);
      if(strlen(destpath)>1) {
        sprintf(newpath,"%s/%s",destpath,newfilename);
      } else {
        sprintf(newpath,"%s%s",destpath,newfilename);
      }
      _freesafe(newfilename);
    } else {
      newpath=(char*)_allocsafe(strlen(destpath)+1+strlen(fe->name)+1);
      if(strlen(destpath)>1) {
        sprintf(newpath,"%s/%s",destpath,fe->name);
      } else {
        sprintf(newpath,"%s%s",destpath,fe->name);
      }
    }
    /* in newpath steht jetzt also der neue Name des Eintrages */
    /* Test auf Existenz des Zieleintrages */
    makecopy=TRUE;
    destexists=FALSE;
    error=stat(newpath,&statbuf);
    if(error==0) {
      /* Ziel exisiert */
      destexists=TRUE;
      isdir=FALSE;
      if(S_ISDIR(statbuf.st_mode)) {
        isdir=TRUE;
        lstat(newpath,&statbuf);
        if(S_ISLNK(statbuf.st_mode)) {
          isdir=FALSE;
        }
      }
      if((overwriteall==FALSE)&&(overwritenone==FALSE)&&(isdir==FALSE)) {
        tstr=(char*)_allocsafe(strlen(_locale[133])+strlen(newpath)+1);
        sprintf(tstr,_locale[133],newpath);
        infotext[0]=tstr;
        tstr=(char*)_allocsafe(strlen(_locale[134])+1);
        strcpy(tstr,_locale[134]);
        infotext[1]=tstr;
        buttontext[0]=_locale[11];
        buttontext[1]=_locale[135];
        buttontext[2]=_locale[136];
        buttontext[3]=_locale[137];
        buttontext[4]=_locale[8];
        x=_Request(_locale[125],2,infotext,5,buttontext);
        _freesafe(infotext[0]);
        _freesafe(infotext[1]);
        if(x==0) {
          overwrite=TRUE;
        } else if(x==1) {
          overwriteall=TRUE;
          *flag=(*flag)|2;
        } else if(x==3) {
          overwrite=FALSE;
        } else if(x==2) {
          overwritenone=TRUE;
          *flag=(*flag)|4;
        } else {
          overwrite=FALSE;
          makecopy=FALSE;
          *abbruch=TRUE;
        }
      }
    }
    if((*abbruch==FALSE)&&(makecopy==TRUE)) {
      makecopy=FALSE;
      if(destexists==FALSE) makecopy=TRUE;
      else {
        if(overwrite==TRUE) makecopy=TRUE;
	else {
	  if((overwritenone==FALSE)&&(overwriteall==TRUE)) makecopy=TRUE;
	}
        if(isdir==TRUE) {
          makecopy=TRUE;
        }
      }
      if(makecopy==TRUE) {
        infotext[0]=(char*)_allocsafe(strlen(_locale[116])+1+strlen(fe->name)+1);
        sprintf(infotext[0],_locale[116],fe->name);
        infotext[1]=(char*)_allocsafe(strlen(_locale[117])+1+strlen(newpath)+1);
        sprintf(infotext[1],"%s %s",_locale[117],newpath);
        _NL_SetCopyWinText(gfxwin,infotext);
	isdir=FALSE;
	copyfile=FALSE;
        if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
	  isdir=TRUE;
	  copyfile=TRUE;
          if(fe->islink==TRUE) {
            isdir=FALSE;
          }
        } else {
          if(fe->islink==TRUE) {
            copyfile=TRUE;
          } else {
            if(S_ISREG(fe->mode)) {
              copyfile=TRUE;
            }
          }
        }
	if(copyfile==TRUE) {
	  if(isdir==FALSE) {
            if(tdir1->ops_perm==0) {
              x=_NL_CopyNewFile(fe,newpath,gfxwin,*files,*dirs,bytes,starttimep);
	      if(x!=0) {
	        /* irgendwas hat nicht geklappt */
                if((x&1)==1) {
                  *abbruch=TRUE;
                }
                if(x>=2) {
                  tdir1->ops_perm=1;
                }
                returnvalue=returnvalue|1;
              } else {
                opok=TRUE;
                (*files)--;
              }
            } else {
              (*files)--;
            }
	  } else {
            if(tdir1->ops_perm==0) {
	      tdir2=tdir1->sub;
  	      while(strcmp(tdir2->dirname,fe->name)!=0) {
	        tdir2=tdir2->right;
	        if(tdir2==NULL) break;
	      }
  	      /* tdir suchen */
	      if(tdir2==NULL) {
	        /* das darf eigentlich nie passieren */
                printf("panic error 01\n");
	      } else {
                godir=FALSE;
	        error=mkdir(newpath,0755);
                if(error!=0) {
                  if(errno==EEXIST) {
		    /* ist nicht so schlimm */
                    godir=TRUE;
                  } else if(errno==EACCES) {
                    /* Verzeichnis <destpath> durfte nicht erstellt werden */
                    tstr=(char*)_allocsafe(strlen(_locale[193])+strlen(destpath)+1);
                    sprintf(tstr,_locale[193],destpath);
                    infotext[0]=tstr;
                    buttontext[0]=_locale[11];
                    buttontext[1]=_locale[8];
                    x=_Request(_locale[125],1,infotext,2,buttontext);
                    _freesafe(infotext[0]);
                    if(x==0) {
                      tdir1->ops_perm=1;
                    } else {
                      tdir1->ops_perm=1;
                      *abbruch=TRUE;
                    }
                    returnvalue=returnvalue|2;
                  } else if(errno==EROFS) {
                    /* Auf diesem schreibgeschtzten Datentrger kann nichts erstellt */
                    infotext[0]=_locale[194];
                    buttontext[0]=_locale[11];
                    buttontext[1]=_locale[8];
                    x=_Request(_locale[125],1,infotext,2,buttontext);
                    if(x==0) {
                      tdir1->ops_perm=1;
                    } else {
                      tdir1->ops_perm=1;
                      *abbruch=TRUE;
                    }
                    returnvalue=returnvalue|2;
                  }
                } else godir=TRUE;
  	        if(((*abbruch)==FALSE)&&(godir==TRUE)) {
                  /* rekursiver Aufruf */
                  x=_NL_RecCopy(tdir2,gfxwin,NULL,0,newpath,abbruch,flag,files,dirs,bytes,starttimep);
  		  if(x!=0) {
  		    /* wieder Fehler */
                    returnvalue=returnvalue|x;
	  	  } else opok=TRUE;
                  /* Flags aktualisieren */
                  if(((*flag)&2)==2) overwriteall=TRUE; else overwriteall=FALSE;
                  if(((*flag)&4)==4) overwritenone=TRUE; else overwritenone=FALSE;
                  /* newpath-Mod ndern */
	  	  chmod(newpath,(fe->mode)&07777);
                }
                (*dirs)--;
              }
            } else {
              /* Dateien und Bytes in Subdir berechnen */
	      tdir2=tdir1->sub;
  	      while(strcmp(tdir2->dirname,fe->name)!=0) {
	        tdir2=tdir2->right;
	        if(tdir2==NULL) break;
	      }
	      if(tdir2==NULL) {
                printf("panic error 01\n");
	      } else {
                _NL_DirValues(tdir2,&tfiles,&tdirs,&tbytes);
                *files-=tfiles;
                *dirs-=tdirs;
                bytes[0]+=tbytes;
              }
            }
          }
	}
        /* Abbruch-Button abfragen */
        if(_NL_CheckCancel(gfxwin)==TRUE) *abbruch=TRUE;
      } else {
        /* makecopy=FALSE */
        returnvalue=returnvalue|(-2);
      }
    }
    if(rootdir==TRUE) {
      if(opok==TRUE) {
        DeSelect(&entry,maxdisplayv,lv,&lvc);
      } else {
        do {
          lvc=lvc->next;
          entry++;
          if(lvc==NULL) break;
        } while(lvc->select==FALSE);
      }
    }
    _freesafe(newpath);
    fe=fe->next;
  }
  return returnvalue;
}

/****************************************************************************************
  Ende Copy-Fkt.
 ****************************************************************************************/

/****************************************************************************************
  Delete-Fkt.
 ****************************************************************************************/

void _UpdateDeleteWin(_GfxWin *gfxwin,char *filename,unsigned long dirs,unsigned long files,unsigned long ffiles)
{
  _Text *gtext;
  _SolidButton *gsolidbutton;
  char *tstr;
  int w;
  float fa;
  gtext=gfxwin->GUI.text;
  gsolidbutton=gfxwin->GUI.solidbutton;
  _BeginRefresh(gfxwin);
  tstr=(char*)_allocsafe(strlen(_locale[141])+strlen(filename)+1);
  if(tstr!=NULL) {
    sprintf(tstr,_locale[141],filename);
    _freesafe(gtext->text);
    gtext->text=tstr;
    _GUIDrawText(gfxwin,gtext,BUFFER);
    _FlushWin(gfxwin,0,gtext->y-_CharHeight,gfxwin->width,_NBH);
  }
  gtext=gtext->next;
  tstr=(char*)_allocsafe(strlen(_locale[142])+50+1);
  if(tstr!=NULL) {
    sprintf(tstr,"%s: %ld",_locale[142],files);
    _freesafe(gtext->text);
    gtext->text=tstr;
    _GUIDrawText(gfxwin,gtext,BUFFER);
    _FlushWin(gfxwin,0,gtext->y-_CharHeight,gfxwin->width,_NBH);
  }
  gtext=gtext->next;
  tstr=(char*)_allocsafe(strlen(_locale[143])+50+1);
  if(tstr!=NULL) {
    sprintf(tstr,"%s: %ld",_locale[143],dirs);
    _freesafe(gtext->text);
    gtext->text=tstr;
    _GUIDrawText(gfxwin,gtext,BUFFER);
    _FlushWin(gfxwin,0,gtext->y-_CharHeight,gfxwin->width,_NBH);
  }
  w=gfxwin->width-20;
  fa=(ffiles-files)*100;
  if(ffiles==0) fa=100;
  else fa=fa/ffiles;
  w*=fa/100;
  gsolidbutton->width=w;
  tstr=(char*)_allocsafe(50);
  if(tstr!=NULL) {
    sprintf(tstr,"%3.4g %%",fa);
    _freesafe(gsolidbutton->text);
    gsolidbutton->text=tstr;
    _GUIDrawSolidButton(gfxwin,gsolidbutton,BUFFER);
    _GUIDrawBevelBox(gfxwin,gfxwin->GUI.bevelbox,BUFFER);
    _FlushWin(gfxwin,0,gsolidbutton->y,gfxwin->width,gsolidbutton->height);
  }
}

void _NL_DeleteOp(int pointerinfo,void *info)
{
  _ListView *lv;
  _RealLister *rl;
  int nr;
  _FileEntry *fe,*tfe;
  _ListViewContent *lvc;
  int effheight,maxdisplayv,x,entry;
  int w,h,moving;
  char *tstr,*path,*path2;
  bool abbruch,rootdir;
  long flag;
  _CDirEntry *maindir,*tdir1;
  _GfxWin *gfxwin;
  _Message *msg;
  bool ignoredir,opok=FALSE;
  unsigned long files,dirs,byteanz,fileanz;
  char *infotext[10];
  char *buttontext[5];
  int offset;
  bool delfile;
  unsigned long ffiles;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  lv=mainstruct.lister[nr].lv;

  if(rl->FEDir[nr]==NULL) return;
  if((rl->dirnr[nr][0]==0)&&(rl->filenr[nr][0]==0)) return;

  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }
  if(rl->dirnr[nr][0]>0) {
    infotext[0]=_locale[145];
    infotext[1]=_locale[146];
    buttontext[0]=_locale[11];
    buttontext[1]=_locale[8];
    x=_Request(_locale[125],2,infotext,2,buttontext);
  } else {
    infotext[0]=_locale[144];
    buttontext[0]=_locale[11];
    buttontext[1]=_locale[8];
    x=_Request(_locale[125],1,infotext,2,buttontext);
  }
  if(x==1) return;

  w=mainwin->width*9/10;
  h=50+3*_NBH+2*_BBH;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,0,w,h,0,h,0,_localecoms[DELETE],PMinSize|PMaxSize,NULL);
  if(gfxwin==NULL) {printf("No memory\n");return;}
  _CreateText(gfxwin,10,5+_CharHeight,1,_locale[140]);
  _CreateText(gfxwin,10,10+_NBH+_CharHeight,1,_locale[142]);
  _CreateText(gfxwin,10,15+2*_NBH+_CharHeight,1,_locale[143]);
  _CreateBevelBox(gfxwin,9,30+3*_NBH-1,w-18,_BBH+2,HIGH);
  _CreateSolidButton(gfxwin,10,30+3*_NBH,0,_BBH,2,3,"");
  _CreateBevelBox(gfxwin,5,35+3*_NBH+_BBH,w-10,2,NORMAL);
  x=strlen(_locale[8])+2;
  x*=_CharWidth;
  _CreateButton(gfxwin,w/2-x/2,40+3*_NBH+_BBH,x,_BBH,1,0,_locale[8],FALSE,0,0,"",1);
  _RedrawWin(gfxwin);
  XFlush(_GlobalGUI.Dsp);

  maindir=(_CDirEntry*)_allocsafe(sizeof(_CDirEntry));
  maindir->parent=NULL;
  maindir->left=NULL;
  maindir->right=NULL;
  maindir->sub=NULL;
  maindir->first=rl->FEDir[nr];
  maindir->checked=FALSE;
  maindir->ops_perm=0;
  maindir->error_occ=FALSE;
  tstr=(char*)_allocsafe(1);
  tstr[0]=0;
  maindir->dirname=tstr;
  maindir->dirfullname=NULL;
  /* Erstellung der Database */
  dirs=0;
  files=0;
  _CreateDirLevel(maindir,0,&fileanz,&byteanz);
  files+=fileanz;
  abbruch=FALSE;
  tdir1=maindir->sub;
  while((tdir1!=NULL)&&(abbruch==FALSE)) {
    if((tdir1->sub==NULL)&&(tdir1->checked==FALSE)) {
      _CreateDirLevel(tdir1,0,&fileanz,&byteanz);
      files+=fileanz;
      dirs++;
    } else {
      if((tdir1->sub!=NULL)&&(tdir1->sub->checked==FALSE)) {
        tdir1=tdir1->sub;
      } else {
        if((tdir1->sub!=NULL)&&(tdir1->sub->checked==FALSE)) {
          tdir1=tdir1->sub;
        } else if((tdir1->right!=NULL)&&(tdir1->right->checked==FALSE)) {
          tdir1=tdir1->right;
        } else {
          tdir1=tdir1->parent;
        }
      }
    }
    msg=_GetMessage(gfxwin);
    if(msg!=NULL) {
      if(msg->type==ButtonRelease) abbruch=TRUE;
      if(msg->type==KeyRelease) {
        if(msg->key==XK_Escape) abbruch=TRUE;
      }
      _ReplyMessage(msg);
    }
  }
  /* Grundstruktur erstellt */
  /* Struktur durchwandern */

  effheight=lv->height-4-lv->hbar_height;
  maxdisplayv=_MaxDisplayV(mainwin,effheight);
  tstr=(char*)_allocsafe(1);
  tstr[0]=0;
  path=tstr;
  ignoredir=FALSE;

  ffiles=files;
  offset=0;

  tdir1=maindir;
  lvc=lv->first;
  entry=0;
  if(lvc->select==TRUE) {
    lvc->select=FALSE;
    _NL_SelectProc(lv,lvc);
    x=entry-lv->vbar_startpos+1;
    while(x>maxdisplayv) {
      lv->vbar_startpos++;
      lv->topcontent=lv->topcontent->next;
      x=entry-lv->vbar_startpos+1;
    }
    while(x<1) {
      lv->vbar_startpos--;
      lv->topcontent=lv->topcontent->prev;
      x=entry-lv->vbar_startpos+1;
    }
  }
  while(lvc->select==FALSE) {
    lvc=lvc->next;
    entry++;
    if(lvc==NULL) break;
  }
  while((tdir1!=NULL)&&(abbruch==FALSE)) {
    moving=-1;
    if(tdir1->sub!=NULL) if(tdir1->sub->checked==TRUE) moving=1;
    if(moving==-1) {
      if(tdir1->right!=NULL) moving=0;
    }
    if(moving<1) {
      /* Alle Dateien lschen, alle Unterverz. wurden schon bearbeitet */
      if(tdir1->parent==NULL) rootdir=TRUE; else rootdir=FALSE;      
      fe=tdir1->first->next;
      while((fe!=NULL)&&(abbruch==FALSE)) {
        /* Entry fe bearbeiten */
        if(((rootdir==TRUE)&&(fe->select==TRUE)&&(fe->infilter==TRUE))||(rootdir==FALSE)) {
          delfile=FALSE;
          if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
            if(fe->islink==TRUE) {
              delfile=TRUE;
            }
          } else {
            delfile=TRUE;
          }
	  opok=TRUE;
          if(delfile==TRUE) {
            x=remove(fe->fullname);
            if(x!=0) {
              tstr=(char*)_allocsafe(strlen(_locale[138])+strlen(fe->fullname)+1);
              sprintf(tstr,_locale[138],fe->fullname);
              infotext[0]=tstr;
              buttontext[0]=_locale[11];
              buttontext[1]=_locale[8];
              x=_Request(_locale[125],1,infotext,2,buttontext);
              _freesafe(infotext[0]);
              if(x!=0) abbruch=TRUE;
	      opok=FALSE;
            }
            files--;
          } else {
            x=rmdir(fe->fullname);
            if(x!=0) {
              tstr=(char*)_allocsafe(strlen(_locale[147])+strlen(fe->fullname)+1);
              sprintf(tstr,_locale[147],fe->fullname);
              infotext[0]=tstr;
              buttontext[0]=_locale[11];
              buttontext[1]=_locale[8];
              x=_Request(_locale[125],1,infotext,2,buttontext);
              _freesafe(infotext[0]);
              if(x!=0) abbruch=TRUE;
	      opok=FALSE;
            }
            dirs--;
          }
          _UpdateDeleteWin(gfxwin,fe->fullname,dirs,files,ffiles);
        }
        while((msg=_GetMessage(gfxwin))!=NULL) {
          if(msg->type==ButtonRelease) break;
          if(msg->type==KeyRelease) break;
          _ReplyMessage(msg);
        }
        if(msg!=NULL) {
          if(msg->type==ButtonRelease) {
            if(msg->gadgettype==BUTTON_GADGET) abbruch=TRUE;
          }
          if(msg->type==KeyRelease) {
            if(msg->key==XK_Escape) abbruch=TRUE;
          }
          _ReplyMessage(msg);
        }
        if(rootdir==TRUE) {
          if((fe->select==TRUE)&&(fe->infilter==TRUE)) {
            if(opok==TRUE) {
              /* fe entfernen */
              fe->prev->next=fe->next;
              if(fe->next!=NULL) fe->next->prev=fe->prev;
              if(rl->activefe[nr]==fe) rl->activefe[nr]=fe->prev;
              tfe=fe->prev;
              /* fe freilassen */
              _freesafe(fe->name);
              _freesafe(fe->fullname);
              _freesafe(fe);
              fe=tfe;
            } else {
            }
          }
        }
        fe=fe->next;
      }
      /* eine Stufe zurck im Dateisystem (path=_Parent(path,NULL)... */
      path2=_Parent(path,NULL);
      _freesafe(path);
      path=path2;
      if((strlen(path)<2)&&(path[0]=='/')) {
        _freesafe(path);
        path=(char*)_allocsafe(1);
        path[0]=0;
      }
//      dirs--;
      tdir1->checked=FALSE;
      if(moving==-1) {
        if(tdir1->error_occ==TRUE) {
          if(tdir1->parent!=NULL) tdir1->parent->error_occ=TRUE;
        }
        tdir1=tdir1->parent;
      }
    }
    if(moving>-1) {
      if(moving==0) {
        if(tdir1->error_occ==TRUE) {
          if(tdir1->parent!=NULL) {
            if(tdir1->parent->parent!=NULL) {
              tdir1->right->error_occ=TRUE;
            }
          }
        }
        tdir1=tdir1->right;
      } else {
        tdir1=tdir1->sub;
      }
      /* tdir1->dirname ->path */
      if(tdir1->parent!=NULL) {
        /* neuen path erstellen */
        if(strlen(tdir1->dirname)>0) {
          path2=(char*)_allocsafe(strlen(path)+1+strlen(tdir1->dirname)+1);
          strcpy(path2,path);
          if(strlen(path2)>0) strcat(path2,"/");
          strcat(path2,tdir1->dirname);
          _freesafe(path);
          path=path2;
        }
      }
    }
  }  
  _freesafe(path);
  /* Database lschen */
  _NL_FreeDirList(maindir);
  _NL_RebuildLister(nr);
  _CloseWindow(gfxwin);
}

/****************************************************************************************
  Ende Delete-Fkt.
 ****************************************************************************************/

/****************************************************************************************
  Rename-Fkt.
 ****************************************************************************************/

void _NL_RenameOp(int pointerinfo,void *info)
{
  _FileEntry *fe,*actfe;
  _ListViewContent *lvc;
  struct stat statbuf;
  char *newname,*tstr,*tstr2,*infotext[2],*buttontext[2],*newname2=NULL;
  int x,entry,effheight,maxdisplayv=0,error;
  bool nameok,abbruch,opok=FALSE,takeactive;
  _ListView *lv;
  _RealLister *rl;
  int nr;
  long flag;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  lv=mainstruct.lister[nr].lv;

  if(rl->FEDir[nr]==NULL) return;
  takeactive=FALSE;
  if((rl->dirnr[nr][0]==0)&&(rl->filenr[nr][0]==0)) {
    if(rl->activefe[nr]==NULL) return;
    else takeactive=TRUE;
  }

  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }

  fe=rl->FEDir[nr];
  actfe=rl->activefe[nr];
  lvc=lv->first;
  entry=0;
  if(lvc->select==TRUE) {
    lvc->select=FALSE;
    _NL_SelectProc(lv,lvc);
    x=entry-lv->vbar_startpos+1;
    while(x>maxdisplayv) {
      lv->vbar_startpos++;
      lv->topcontent=lv->topcontent->next;
      x=entry-lv->vbar_startpos+1;
    }
    while(x<1) {
      lv->vbar_startpos--;
      lv->topcontent=lv->topcontent->prev;
      x=entry-lv->vbar_startpos+1;
    }
  }
  while(lvc->select==FALSE) {
    if(takeactive==TRUE) {
      if(lvc->active==TRUE) break;
    }
    lvc=lvc->next;
    entry++;
    if(lvc==NULL) break;
  }
  abbruch=FALSE;
  effheight=lv->height-4-lv->hbar_height;
  maxdisplayv=_MaxDisplayV(mainwin,effheight);
  while((fe!=NULL)&&(abbruch==FALSE)) {
    if(fe->infilter==TRUE) {
      if((fe->select==TRUE)||((takeactive==TRUE)&&(fe==actfe))) {
        if(fe->prev!=NULL) {
          opok=FALSE;
          nameok=FALSE;
          while(nameok==FALSE) {
            newname=_RequestNewName(fe->name);
            if(newname!=NULL) {
              tstr=(char*)_allocsafe(strlen(rl->Dir[nr])+1+strlen(newname)+1);
              strcpy(tstr,rl->Dir[nr]);
              if(strlen(tstr)>1) strcat(tstr,"/");
              strcat(tstr,newname);
              if(strcmp(tstr,fe->fullname)==0) error=-1;
              else error=stat(tstr,&statbuf);
              if(error!=0) {
                newname2=newname;
                newname=tstr;
                nameok=TRUE;
              } else {
                tstr2=(char*)_allocsafe(strlen(_locale[133])+strlen(tstr)+1);
                sprintf(tstr2,_locale[133],tstr);
                infotext[0]=tstr2;
                infotext[1]=_locale[150];
                buttontext[0]=_locale[11];
                buttontext[1]=_locale[8];
                x=_Request(_locale[125],2,infotext,2,buttontext);
                _freesafe(infotext[0]);
                _freesafe(newname);
                _freesafe(tstr);
                if(x==0) {
                 nameok=FALSE;
                } else {
                  nameok=TRUE;
                  newname=NULL;
                  abbruch=TRUE;
                }
              }
            } else {
              nameok=TRUE;
              abbruch=TRUE;
            }
          }
          if((newname!=NULL)&&(abbruch==FALSE)) {
            if(strcmp(newname,fe->fullname)!=0) {
              x=rename(fe->fullname,newname);
              if(x!=0) {
                infotext[0]=_locale[151];
                _Request(_locale[125],1,infotext,1,&_locale[11]);
              } else opok=TRUE;
              _freesafe(fe->name);
              fe->name=newname2;
              _BuildLVC(fe,lvc,nr);
              _freesafe(newname);
            } else {
              _freesafe(newname);
              _freesafe(newname2);
            }
          }
        }
        if(opok==TRUE) DeSelect(&entry,maxdisplayv,lv,&lvc);
        else {
          lvc=lvc->next;
          entry++;
          if(lvc!=NULL) {
            while(lvc->select==FALSE) {
              lvc=lvc->next;
              entry++;
              if(lvc==NULL) break;
            }
          }
        }
      }
    }
    fe=fe->next;
  }
  _NL_UpdateDir(PISNUMBER,&nr);
}

/****************************************************************************************
  Ende Rename-Fkt.
 ****************************************************************************************/

/****************************************************************************************
  MakeDir-Fkt.
 ****************************************************************************************/

void _NL_MakeDirOp(int pointerinfo,void *info)
{
  _GfxWin *gfxwin;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *nnsg;
  _FileEntry *fe;
  _ListViewContent *lvc;
  int w,h;
  int x=0,y,maxdisplayv,effheight;
  char *tstr,*dirname,*tstr2;
  char *infotext[1];
  char *buttontext[1];
  bool okay=FALSE;
  _ListView *lv;
  _RealLister *rl;
  int nr,entry;
  long flag;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  lv=mainstruct.lister[nr].lv;

  if(rl->FEDir[nr]==NULL) return;

  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }

  w=strlen(_locale[152]);
  w*=_CharWidth;
  w+=20;
  h=3*_BBH+3*10;
  dirname=NULL;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,0,w,h,0,h,_WConfig.requestbg,_localecoms[MAKEDIR],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateText(gfxwin,10,5+_CharHeight,1,_locale[152]);
    nnsg=_CreateStringGadget(gfxwin,10,10+_BBH,w-20,_NBH+6,"",256,_WConfig.unsel_pathfg,_WConfig.unsel_pathbg,_WConfig.sel_pathfg,_WConfig.sel_pathbg,3);
    _CreateButton(gfxwin,10,h-5-_BBH,(strlen(_locale[11])+2)*_CharWidth,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-(strlen(_locale[8])+2)*_CharWidth,h-5-_BBH,(strlen(_locale[8])+2)*_CharWidth,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    _HandleStringGadget(gfxwin,nnsg,NULL);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) okay=TRUE;
            else if(tbutton->data==2) okay=FALSE;
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } if(msg->type==KeyRelease) {
          if(msg->key==XK_Return) {
            okay=TRUE;
            _ReplyMessage(msg);
            break;
          } else if(msg->key==XK_Escape) {
            okay=FALSE;
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    if(okay==TRUE) {
      dirname=(char*)_allocsafe(strlen(nnsg->string)+1);
      strcpy(dirname,nnsg->string);
      if(strlen(dirname)>0) {
        tstr=(char*)_allocsafe(strlen(rl->Dir[nr])+1+strlen(dirname)+1);
        strcpy(tstr,rl->Dir[nr]);
        if(strlen(tstr)>1) strcat(tstr,"/");
        strcat(tstr,dirname);
        x=mkdir(tstr,S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
        if(x!=0) {
          tstr2=(char*)_allocsafe(strlen(_locale[126])+strlen(tstr)+1);
          sprintf(tstr2,_locale[126],tstr);
          infotext[0]=tstr2;
          buttontext[0]=_locale[11];
          _Request(_locale[125],1,infotext,1,&_locale[11]);
          _freesafe(infotext[0]);
        }
        _freesafe(tstr);
      }
    }
    _CloseWindow(gfxwin);
    _NL_UpdateDir(PISNUMBER,&nr);
    if((x==0)&&(okay==TRUE)) {
      fe=rl->FEDir[nr];
      while(strcmp(dirname,fe->name)!=0) {
        fe=fe->next;
        if(fe==NULL) break;
      }
      if(fe!=NULL) {
        y=fe->nr;
        lvc=lv->first;
	entry=0;
        while(lvc->data!=y) {
	  lvc=lvc->next;
	  entry++;
	}
        _NL_SelectProc(lv,lvc);
        x=entry-lv->vbar_startpos+1;
        effheight=lv->height-4-lv->hbar_height;
        maxdisplayv=_MaxDisplayV(mainwin,effheight);
        while(x>maxdisplayv) {
          lv->vbar_startpos++;
          lv->topcontent=lv->topcontent->next;
          x=entry-lv->vbar_startpos+1;
        }
        while(x<1) {
          lv->vbar_startpos--;
          lv->topcontent=lv->topcontent->prev;
          x=entry-lv->vbar_startpos+1;
        }
        _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
        _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
      }
    }
    if(dirname!=NULL) _freesafe(dirname);
  }
}

/****************************************************************************************
  Ende MakeDir-Fkt.
 ****************************************************************************************/

/****************************************************************************************
  Move-Fkt.
 ****************************************************************************************/

struct filelist { char *fullname;
                  bool isdir;
                  struct filelist *next;};

int _NL_RecMove(_CDirEntry *tdir,_GfxWin *gfxwin,char *destpath,bool *abbruch,long *flag,unsigned long *files,unsigned long *dirs,unsigned long bytes[2],time_t *starttimep,struct filelist **first,struct filelist **last);

void Add2FileList(struct filelist **first,struct filelist **last,const char *name,bool isdir)
{
  struct filelist *temp;
  temp=(struct filelist*)_allocsafe(sizeof(struct filelist));
  temp->fullname=dupstring(name);
  temp->isdir=isdir;
  temp->next=NULL;
  if(*first!=NULL) {
    (*last)->next=temp;
    *last=temp;
  } else {
    *first=temp;
    *last=temp;
  }
}

void RemoveFiles(_GfxWin *gfxwin,struct filelist *first)
{
  bool abbruch;
  struct filelist *tf,*tf2;
  char *tstr[2],*infotext[1],*buttontext[2],*tstr2;
  int x;
  
  abbruch=FALSE;
  tf=first;
  while(tf!=NULL) {
    if(abbruch==FALSE) {
      tstr[1]=(char*)_allocsafe(1);
      tstr[1][0]=0;
      tstr[0]=(char*)_allocsafe(strlen(_locale[141])+strlen(tf->fullname)+1);
      sprintf(tstr[0],_locale[141],tf->fullname);
      _NL_SetCopyWinText(gfxwin,tstr);
      if(tf->isdir==FALSE) {
        x=remove(tf->fullname);
        if(x!=0) {
          tstr2=(char*)_allocsafe(strlen(_locale[138])+strlen(tf->fullname)+1);
          sprintf(tstr2,_locale[138],tf->fullname);
          infotext[0]=tstr2;
          buttontext[0]=_locale[11];
          buttontext[1]=_locale[8];
          x=_Request(_locale[125],1,infotext,2,buttontext);
          _freesafe(infotext[0]);
          if(x!=0) {
            abbruch=TRUE;
          }
        }
      } else {
        x=rmdir(tf->fullname);
        if(x!=0) {
          tstr2=(char*)_allocsafe(strlen(_locale[147])+strlen(tf->fullname)+1);
          sprintf(tstr2,_locale[147],tf->fullname);
          infotext[0]=tstr2;
          buttontext[0]=_locale[11];
          buttontext[1]=_locale[8];
          x=_Request(_locale[125],1,infotext,2,buttontext);
          _freesafe(infotext[0]);
          if(x!=0) abbruch=TRUE;
        }
      }
    }
    _freesafe(tf->fullname);
    tf2=tf->next;
    _freesafe(tf);
    tf=tf2;
    if(_NL_CheckCancel(gfxwin)==TRUE) abbruch=TRUE;
  }
}

void _NL_MoveOp(int pointerinfo,void *info)
{
  _ListView *lv;
  _RealLister *rl;
  int nr,onr;
  _ListViewContent *lvc;
  int effheight,maxdisplayv,x,entry;
  int w,h,ty;
  char *tstr,*path;
  bool abbruch,takeactive,oldstate=FALSE;
  long flag;
  _CDirEntry *maindir,*tdir1;
  _GfxWin *gfxwin;
  _Message *msg;
  char *destpath;
  int sourcenr;
  bool overwriteall,overwritenone,renameflag,requestpath;
  unsigned long bytes[2];
  unsigned long files,dirs,byteanz,fileanz;
  time_t starttimep;
  struct filelist *first,*last;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  onr=(nr==1)?0:1;
  lv=mainstruct.lister[nr].lv;

  requestpath=FALSE;
  if(rl->FEDir[nr]==NULL) return;
  if(mainstruct.lister[onr].activemode!=0) {
    /* anderen Modus */
    requestpath=TRUE;
  }
  if(rl->FEDir[onr]==NULL) requestpath=TRUE;
  takeactive=FALSE;
  if((rl->dirnr[nr][0]==0)&&(rl->filenr[nr][0]==0)) {
    if(rl->activefe[nr]==NULL) return;
    else takeactive=TRUE;
  }

  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }
  if((flag&8)==8) {
    if(_RequestActionFlags(&flag,MOVE)==FALSE) return;
  }
  sourcenr=nr;
  if(requestpath==FALSE) {
    destpath=(char*)_allocsafe(strlen(rl->Dir[onr])+1);
    strcpy(destpath,rl->Dir[onr]);
  } else {
    destpath=StringRequest(rl->Dir[nr],_locale[123],_locale[212]);
    if(destpath==NULL) return;
  }
  bytes[0]=0;
  bytes[1]=0;

  w=mainwin->width*9/10;
  h=5;
  h+=_CharHeight+5;
  h+=_CharHeight+5;
  h+=_BBH+2+5;
  h+=2+5;
  h+=_CharHeight+5;
  h+=_CharHeight+5;
  h+=_CharHeight+5;
  h+=_BBH+2+5;
  h+=_CharHeight+5;
  h+=2+5;
  h+=_BBH+5;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_localecoms[MOVE],PMinSize|PMaxSize,NULL);
  if(gfxwin==NULL) {printf("No memory\n");return;}
  ty=5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[122]);
  ty+=_CharHeight+5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,"");
  ty+=_CharHeight+5;
  _CreateBevelBox(gfxwin,9,ty-1,w-18,_BBH+2,HIGH);
  _CreateSolidButton(gfxwin,10,ty,0,_BBH,2,3,"test");
  ty+=_BBH+2+5;
  _CreateBevelBox(gfxwin,5,ty,w-10,2,NORMAL);
  ty+=2+5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[118]);
  ty+=_CharHeight+5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[119]);
  ty+=_CharHeight+5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[120]);
  ty+=_CharHeight+5;
  _CreateBevelBox(gfxwin,9,ty-1,w-18,_BBH+2,HIGH);
  _CreateSolidButton(gfxwin,10,ty,0,_BBH,2,3,"test2");
  ty+=_BBH+2+5;
  _CreateText(gfxwin,10,ty+_GlobalGUI.font->ascent,1,_locale[121]);
  ty+=_CharHeight+5;
  _CreateBevelBox(gfxwin,5,ty,w-10,2,NORMAL);
  ty+=2+5;
  x=strlen(_locale[8])+2;
  x*=_CharWidth;
  _CreateButton(gfxwin,w/2-x/2,ty,x,_BBH,1,0,_locale[8],FALSE,0,0,"",1);
  _RedrawWin(gfxwin);
  XFlush(_GlobalGUI.Dsp);

  if(takeactive==TRUE) {
    oldstate=rl->activefe[nr]->select;
    rl->activefe[nr]->select=TRUE;
  }
  maindir=(_CDirEntry*)_allocsafe(sizeof(_CDirEntry));
  maindir->parent=NULL;
  maindir->left=NULL;
  maindir->right=NULL;
  maindir->sub=NULL;
  maindir->first=rl->FEDir[sourcenr];
  maindir->checked=FALSE;
  maindir->ops_perm=0;
  maindir->error_occ=FALSE;
  tstr=(char*)_allocsafe(1);
  tstr[0]=0;
  maindir->dirname=tstr;
  maindir->dirfullname=NULL;
  /* Erstellung der Database */
  dirs=0;
  files=0;
  _CreateDirLevel(maindir,0,&fileanz,&byteanz);
  files+=fileanz;
  bytes[1]+=byteanz;
  abbruch=FALSE;
  tdir1=maindir->sub;
  while((tdir1!=NULL)&&(abbruch==FALSE)) {
    if((tdir1->sub==NULL)&&(tdir1->checked==FALSE)) {
      _CreateDirLevel(tdir1,0,&fileanz,&byteanz);
    } else {
      if((tdir1->sub!=NULL)&&(tdir1->sub->checked==FALSE)) {
        tdir1=tdir1->sub;
      } else {
        if((tdir1->sub!=NULL)&&(tdir1->sub->checked==FALSE)) {
          tdir1=tdir1->sub;
        } else if((tdir1->right!=NULL)&&(tdir1->right->checked==FALSE)) {
          tdir1=tdir1->right;
        } else {
          tdir1=tdir1->parent;
        }
      }
    }
    msg=_GetMessage(gfxwin);
    if(msg!=NULL) {
      if(msg->type==ButtonRelease) abbruch=TRUE;
      if(msg->type==KeyRelease) {
        if(msg->key==XK_Escape) abbruch=TRUE;
      }
      _ReplyMessage(msg);
    }
  }
  /* Grundstruktur erstellt */
  /* Struktur durchwandern */

  time(&starttimep);
  if((flag&2)==2) overwriteall=TRUE; else overwriteall=FALSE;
  if((flag&4)==4) overwritenone=TRUE; else overwritenone=FALSE;
  if((flag&8)==8) renameflag=TRUE; else renameflag=FALSE;

  effheight=lv->height-4-lv->hbar_height;
  maxdisplayv=_MaxDisplayV(mainwin,effheight);
  tstr=(char*)_allocsafe(1);
  tstr[0]=0;
  path=tstr;

  tdir1=maindir;
  lvc=lv->first;
  entry=0;
  if(lvc->select==TRUE) {
    lvc->select=FALSE;
    _NL_SelectProc(lv,lvc);
    x=entry-lv->vbar_startpos+1;
    while(x>maxdisplayv) {
      lv->vbar_startpos++;
      lv->topcontent=lv->topcontent->next;
      x=entry-lv->vbar_startpos+1;
    }
    while(x<1) {
      lv->vbar_startpos--;
      lv->topcontent=lv->topcontent->prev;
      x=entry-lv->vbar_startpos+1;
    }
  }
  while(lvc->select==FALSE) {
    if(takeactive==TRUE) {
      if(lvc->active==TRUE) {
        lvc->select=TRUE;
        break;
      }
    }
    lvc=lvc->next;
    entry++;
    if(lvc==NULL) break;
  }
  _NL_ChangeActive(1,rl,nr,NULL);
  first=NULL;
  _NL_RecMove(maindir,gfxwin,destpath,&abbruch,&flag,&files,&dirs,bytes,&starttimep,&first,&last);
  /* Fehler abfangen ^^^
     TODO: brauch ich das berhaupt ? */
  if(abbruch==FALSE) {
    RemoveFiles(gfxwin,first);
  }
  if(takeactive==TRUE) {
    rl->activefe[nr]->select=oldstate;
  }
  _freesafe(path);
  _freesafe(destpath);
  /* Database lschen */
  _NL_FreeDirList(maindir);
/*  _NL_UpdateDir(PISNUMBER,&nr);*/
  _NL_RebuildLister(nr);
  _NL_UpdateDir(PISNUMBER,&onr);
  rl->nextcheck[nr]=rl->FEDir[nr];
  _CloseWindow(gfxwin);
}

bool _NL_CheckCancel(_GfxWin *gfxwin)
{
  _Message *msg;
  bool cancel;
  while((msg=_GetMessage(gfxwin))!=NULL) {
    if(msg->type==ButtonRelease) break;
    if(msg->type==KeyRelease) break;
    if(msg->type==ClientMessage) break;
    _ReplyMessage(msg);
  }
  cancel=FALSE;
  if(msg!=NULL) {
    if(msg->type==ButtonRelease) {
      if(msg->gadgettype==BUTTON_GADGET) cancel=TRUE;
    }
    if(msg->type==KeyRelease) {
      if(msg->key==XK_Escape) cancel=TRUE;
    }
    if(msg->type==ClientMessage) {
      if(msg->gadgettype==CLOSE_GADGET) {
         if(msg->window==gfxwin->Wnd) {
           cancel=TRUE;
         }
       }
     }
    _ReplyMessage(msg);
  }
  return cancel;
}

void _NL_SetCopyWinText(_GfxWin *gfxwin,char *text[2])
{
  /* !!! text darf nicht von aufrufender Proz. freigelassen werden !!!
     die Strings werden aus Performance-Grnden nicht dupliziert */
  _Text *gtext;
  _BeginRefresh(gfxwin);
  gtext=gfxwin->GUI.text;
  _freesafe(gtext->text);
  gtext->text=text[0];
  _GUIDrawText(gfxwin,gtext,BUFFER);
  _FlushWin(gfxwin,0,gtext->y-_GlobalGUI.font->ascent,gfxwin->width,_NBH);
  gtext=gtext->next;
  _freesafe(gtext->text);
  gtext->text=text[1];
  _GUIDrawText(gfxwin,gtext,BUFFER);
  _FlushWin(gfxwin,0,gtext->y-_GlobalGUI.font->ascent,gfxwin->width,_NBH);
}

int _NL_CopyDelFile(_FileEntry *fe,char *newpath,_GfxWin *gfxwin,long files,long dirs,long bytes[2],time_t *starttimep,struct filelist **first,struct filelist **last)
{
  int x,cerror,returnvalue;
  bool abbruch,opok;
  char buffer[4096],*tstr;
  char *buttontext[5],*infotext[5];
  
  opok=FALSE;
  returnvalue=0;
  abbruch=FALSE;
  if(S_ISLNK(fe->lmode)) {
    /* fe->fullname is link */
    x=readlink(fe->fullname,buffer,4095);
    if(x>=0) {
      buffer[x]=0;
      cerror=symlink(buffer,newpath);
      if(cerror!=0) {
        if(errno==EPERM) {
          /* Hinweis, da das FS keine SymLinks untersttzt */
          tstr=(char*)_allocsafe(strlen(_locale[195])+1);
          sprintf(tstr,"%s",_locale[195]);
          infotext[0]=tstr;
          buttontext[0]=_locale[11];
          buttontext[1]=_locale[8];
          x=_Request(_locale[125],1,infotext,2,buttontext);
          _freesafe(infotext[0]);
          if(x!=0) {
            abbruch=TRUE;
          }
        } else if(errno==EACCES) {
          /* Hinweis, da Op nicht erlaubt */
          tstr=(char*)_allocsafe(strlen(_locale[196])+strlen(newpath)+1);
          sprintf(tstr,_locale[196],newpath);
          infotext[0]=tstr;
          buttontext[0]=_locale[11];
          buttontext[1]=_locale[8];
          x=_Request(_locale[125],1,infotext,2,buttontext);
          if(infotext[0]!=NULL) _freesafe(infotext[0]);
          if(x!=0) {
            abbruch=TRUE;
          }
        }
        returnvalue=returnvalue|8;
      } else opok=TRUE;
    } else returnvalue=returnvalue|4;
  } else {
    /* fe->fullname -> destfilename */
    cerror=_CopyFile(fe,newpath,gfxwin,bytes[0],bytes[1],files,dirs,starttimep,&abbruch);
    if(cerror==2) {
      if(errno==EACCES) {
        tstr=(char*)_allocsafe(strlen(_locale[198])+1);
        sprintf(tstr,_locale[198]);
        infotext[0]=tstr;
        infotext[1]=newpath;
        buttontext[0]=_locale[11];
        buttontext[1]=_locale[8];
        x=_Request(_locale[125],2,infotext,2,buttontext);
        if(infotext[0]!=NULL) _freesafe(infotext[0]);
        if(x!=0) {
          abbruch=TRUE;
        }
      } else if(errno==EROFS) {
        tstr=(char*)_allocsafe(strlen(_locale[194])+1);
        sprintf(tstr,_locale[194]);
        infotext[0]=tstr;
        buttontext[0]=_locale[11];
        buttontext[1]=_locale[8];
        x=_Request(_locale[125],1,infotext,2,buttontext);
        _freesafe(infotext[0]);
        if(x!=0) {
          abbruch=TRUE;
        }
      } else if(errno==ENOSPC) {
        tstr=(char*)_allocsafe(strlen(_locale[197])+1);
        sprintf(tstr,_locale[197]);
        infotext[0]=tstr;
        buttontext[0]=_locale[11];
        buttontext[1]=_locale[8];
        x=_Request(_locale[125],1,infotext,2,buttontext);
        if(infotext[0]!=NULL) _freesafe(infotext[0]);
        if(x!=0) {
          abbruch=TRUE;
        }
      }
      returnvalue=returnvalue|16;
    } else if(cerror==1) {
      /* TODO: Fehlerhandling einbauen */
    } else opok=TRUE;
    bytes[0]+=fe->size;
  }
  if((opok==TRUE)&&(abbruch==FALSE)) {
    Add2FileList(first,last,fe->fullname,FALSE);
  }
  if(abbruch==TRUE) returnvalue=returnvalue|1;
  return returnvalue;
  /* Format: Bit 0 abbruch
             Bit 1 Ursprungsdatei konnte nicht entfernt werden
             Bit 2 SymLink konnte nicht gelesen werden
             Bit 3 SymLink konnte nicht erstellt werden
             Bit 4 Datei konnte nicht kopiert werden */
}

int _NL_RecMove(_CDirEntry *tdir,_GfxWin *gfxwin,char *destpath,bool *abbruch,long *flag,unsigned long *files,unsigned long *dirs,unsigned long bytes[2],time_t *starttimep,struct filelist **first,struct filelist **last)
{
  _CDirEntry *tdir1,*tdir2;
  char *oldpath,*newpath,*newfilename=NULL,*tstr;
  bool rootdir,takenew,overwriteall,overwritenone,makemove,destexists,overwrite=FALSE;
  bool isdir=FALSE,copyfile,opok,skiprename,godir;
  int returnvalue,error,x;
  _FileEntry *fe,*tfe;
  char *infotext[10];
  char *buttontext[5];
  struct stat statbuf;

  tdir1=tdir;
  if(tdir1->parent==NULL) rootdir=TRUE; else rootdir=FALSE;
  fe=tdir1->first->next;
  returnvalue=0;
  if(((*flag)&1)==1) overwriteall=TRUE; else overwriteall=FALSE;
  if(((*flag)&2)==2) overwritenone=TRUE; else overwritenone=FALSE;
  while((fe!=NULL)&&((*abbruch)==FALSE)) {
    for(;fe!=NULL;) {
      if(rootdir==TRUE) {
        if((fe->select==TRUE)&&(fe->infilter==TRUE)) break;
      } else break;
      fe=fe->next;
    }
    if(fe==NULL) break;
    /* fe bewegen -> destpath*/
    opok=FALSE;
    oldpath=fe->fullname;
    takenew=FALSE;
    if(rootdir==TRUE) {
      if(((*flag)&4)==4) {
        /* neuen Name erfragen */
        newfilename=_GetNewName(fe->name,destpath,S_ISDIR(fe->mode)?TRUE:FALSE);
        if(newfilename!=NULL) {
	  takenew=TRUE;
	} else {
	  takenew=FALSE;
	}
      }
    }
    if(takenew==TRUE) {
      newpath=(char*)_allocsafe(strlen(destpath)+1+strlen(newfilename)+1);
      if(strlen(destpath)>1) {
        sprintf(newpath,"%s/%s",destpath,newfilename);
      } else {
        sprintf(newpath,"%s%s",destpath,newfilename);
      }
      _freesafe(newfilename);
    } else {
      newpath=(char*)_allocsafe(strlen(destpath)+1+strlen(fe->name)+1);
      if(strlen(destpath)>1) {
        sprintf(newpath,"%s/%s",destpath,fe->name);
      } else {
        sprintf(newpath,"%s%s",destpath,fe->name);
      }
    }
    /* in newpath steht jetzt also der neue Name des Eintrages */
    /* Test auf Existenz des Zieleintrages */
    makemove=TRUE;
    destexists=FALSE;
    error=stat(newpath,&statbuf);
    if(error==0) {
      /* Ziel exisiert */
      destexists=TRUE;
      isdir=FALSE;
      if(S_ISDIR(statbuf.st_mode)) {
        isdir=TRUE;
        lstat(newpath,&statbuf);
        if(S_ISLNK(statbuf.st_mode)) {
          isdir=FALSE;
        }
      }
      if((overwriteall==FALSE)&&(overwritenone==FALSE)&&(isdir==FALSE)) {
        tstr=(char*)_allocsafe(strlen(_locale[133])+strlen(newpath)+1);
        sprintf(tstr,_locale[133],newpath);
        infotext[0]=tstr;
        tstr=(char*)_allocsafe(strlen(_locale[134])+1);
        strcpy(tstr,_locale[134]);
        infotext[1]=tstr;
        buttontext[0]=_locale[11];
        buttontext[1]=_locale[135];
        buttontext[2]=_locale[136];
        buttontext[3]=_locale[137];
        buttontext[4]=_locale[8];
        x=_Request(_locale[125],2,infotext,5,buttontext);
        _freesafe(infotext[0]);
        _freesafe(infotext[1]);
        if(x==0) {
          overwrite=TRUE;
        } else if(x==1) {
          overwriteall=TRUE;
          *flag=(*flag)|1;
        } else if(x==3) {
          overwrite=FALSE;
        } else if(x==2) {
          overwritenone=TRUE;
          *flag=(*flag)|2;
        } else {
          overwrite=FALSE;
          makemove=FALSE;
          *abbruch=TRUE;
        }
      }  
    }
    if((*abbruch==FALSE)&&(makemove==TRUE)) {
      makemove=FALSE;
      skiprename=FALSE;
      if(destexists==FALSE) makemove=TRUE;
      else {
        if(overwrite==TRUE) makemove=TRUE;
	else {
	  if((overwritenone==FALSE)&&(overwriteall==TRUE)) makemove=TRUE;
	}
        if(isdir==TRUE) {
          makemove=TRUE;
          skiprename=TRUE;
        }
      }
      if(makemove==TRUE) {
        /* rename() ausfhren */
        infotext[0]=(char*)_allocsafe(strlen(_locale[199])+1+strlen(fe->name)+1);
        sprintf(infotext[0],_locale[199],fe->name);
        infotext[1]=(char*)_allocsafe(strlen(_locale[117])+1+strlen(newpath)+1);
        sprintf(infotext[1],"%s %s",_locale[117],newpath);
        _NL_SetCopyWinText(gfxwin,infotext);
        if(skiprename==FALSE) {
          x=rename(oldpath,newpath);
        } else x=-1;
	if(x!=0) {
          /* falls dies fehlschlug, dann:
             - Datei kopieren und lschen
             - Zielverzeichnis erstellen ->destpath, tdir suchen und
               rekursiv selbstaufrufen */
	  isdir=FALSE;
	  copyfile=FALSE;
          if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
	    isdir=TRUE;
	    copyfile=TRUE;
            if(fe->islink==TRUE) {
              isdir=FALSE;
            }
          } else {
            if(fe->islink==TRUE) {
              copyfile=TRUE;
            } else {
              if(S_ISREG(fe->mode)) {
                copyfile=TRUE;
              }
            }
          }
	  if(copyfile==TRUE) {
	    if(isdir==FALSE) {
	      /* wie bei Copy */
	      /* fe->fullname lschen*/
              if(tdir1->ops_perm==0) {
                x=_NL_CopyDelFile(fe,newpath,gfxwin,*files,*dirs,bytes,starttimep,first,last);
	        if(x!=0) {
	          /* irgendwas hat nicht geklappt */
                  if((x&1)==1) {
                    *abbruch=TRUE;
                  }
                  if(x>=8) {
                    tdir1->ops_perm=1;
                  }
                  returnvalue=returnvalue|1;
                } else {
                  opok=TRUE;
                  (*files)--;
                }
              } else {
                (*files)--;
              }
	    } else {
	      tdir2=tdir1->sub;
	      while(strcmp(tdir2->dirname,fe->name)!=0) {
	        tdir2=tdir2->right;
		if(tdir2==NULL) break;
	      }
	      /* tdir suchen */
	      if(tdir2==NULL) {
	        /* das darf eigentlich nie passieren */
		/* TODO: bessere Fehlerausgabe */
                printf("panic error 01\n");
	      } else {
                godir=FALSE;
		error=mkdir(newpath,0755);
                if(error!=0) {
                  if(errno==EEXIST) {
		    /* ist nicht so schlimm */
                    godir=TRUE;
                  } else if(errno==EACCES) {
                    /* Verzeichnis <destpath> durfte nicht erstellt werden */
                    tstr=(char*)_allocsafe(strlen(_locale[193])+strlen(destpath)+1);
                    sprintf(tstr,_locale[193],destpath);
                    infotext[0]=tstr;
                    buttontext[0]=_locale[11];
                    buttontext[1]=_locale[8];
                    x=_Request(_locale[125],1,infotext,2,buttontext);
                    _freesafe(infotext[0]);
                    if(x==0) {
                      tdir1->ops_perm=1;
                    } else {
                      tdir1->ops_perm=1;
                      *abbruch=TRUE;
                    }
                    returnvalue=returnvalue|2;
                  } else if(errno==EROFS) {
                    /* Auf diesem schreibgeschtzten Datentrger kann nichts erstellt */
                    infotext[0]=_locale[194];
                    buttontext[0]=_locale[11];
                    buttontext[1]=_locale[8];
                    x=_Request(_locale[125],1,infotext,2,buttontext);
                    if(x==0) {
                      tdir1->ops_perm=1;
                    } else {
                      tdir1->ops_perm=1;
                      *abbruch=TRUE;
                    }
                    returnvalue=returnvalue|2;
                  }
                } else godir=TRUE;
		if(((*abbruch)==FALSE)&&(godir==TRUE)) {
                  /* rekursiver Aufruf */
                  (*dirs)++;
                  tfe=tdir2->first->next;
                  while(tfe!=NULL) {
                    /* auf Filter mu nicht geachtet werden, diese Schleife kann nur bei
                       Unterverzeichnissen durchlaufen werden */
                    if((!S_ISDIR(tfe->mode))||(tfe->iscorrupt==TRUE)) {
                      if(tfe->islink==TRUE) {
                        (*files)++;
                      } else {
                        if(S_ISREG(tfe->mode)) {
                          (*files)++;
                          bytes[1]+=tfe->size;
                        }
                      }
                    }
                    tfe=tfe->next;
                  }
                  x=_NL_RecMove(tdir2,gfxwin,newpath,abbruch,flag,files,dirs,bytes,starttimep,first,last);
		  if(x!=0) {
		    /* wieder Fehler */
                    /* TODO: Fehlerhandling
                             so wie es jetzt ist, mte es eigentlich reichen, Fehler werden
                             ja sofort beim auftreten gemeldet und hier interessiert dann
                             nur noch ob und nicht was passiert ist */
                    returnvalue=returnvalue|x;
		  }
                  /* newpath-Mod ndern */
		  chmod(newpath,(fe->mode)&07777);
                  /* fe->fullname lschen */
                  if((*abbruch)==FALSE) {
                    Add2FileList(first,last,fe->fullname,TRUE);
                    opok=TRUE;
                  }
                }
                (*dirs)--;
              }
	    }
	  }
	} else {
          if((!S_ISDIR(fe->mode))||(fe->iscorrupt==TRUE)) {
            if(fe->islink==TRUE) {
              (*files)--;
            } else {
              if(S_ISREG(fe->mode)) {
                (*files)--;
              }
            }
          }
          opok=TRUE;
        }
        /* Fenster aktualisieren */
        if(opok==TRUE) {
          if((rootdir==TRUE)&&(returnvalue==0)) {
            /* fe entfernen */
            fe->prev->next=fe->next;
            if(fe->next!=NULL) fe->next->prev=fe->prev;
            _NL_ChangeActive(0,NULL,0,fe);
            tfe=fe->prev;
            /* fe freilassen */
            _freesafe(fe->name);
            _freesafe(fe->fullname);
            _freesafe(fe);
            fe=tfe;
          }
        }
        /* Abbruch-Button abfragen */
        if(_NL_CheckCancel(gfxwin)==TRUE) *abbruch=TRUE;
      }
    }
    _freesafe(newpath);
    fe=fe->next;
  }
  return returnvalue;
}

void _NL_ChangeActive(int mode,_RealLister *rl,int nr,_FileEntry *fe)
{
  static int Nr;
  static _RealLister *Rl;
  if(mode==1) {
    /* zum Initieren */
    Rl=rl;
    Nr=nr;
  } else {
    /* fr "normalen" Betrieb */
    if(Rl->activefe[Nr]==fe) Rl->activefe[Nr]=fe->prev;
  }
}

/****************************************************************************************
  Ende Move-Fkt.
 ****************************************************************************************/

/****************************************************************************************
  UserCom-Fkt.
 ****************************************************************************************/

struct _userfilelist { char *fullname;
                       char *name;
                       char *fullname_noext;
                       char *name_noext;
                       _FileEntry *rootentry;
                       struct _userfilelist *prev;
                       struct _userfilelist *next; };
                       
struct _userfilelist *_NL_NewUFL(void)
{
  struct _userfilelist *newelem;
  newelem=(struct _userfilelist*)_allocsafe(sizeof(struct _userfilelist));
  newelem->fullname=NULL;
  newelem->name=NULL;
  newelem->fullname_noext=NULL;
  newelem->name_noext=NULL;
  newelem->rootentry=NULL;
  newelem->prev=NULL;
  newelem->next=NULL;
  return newelem;
}

void _NL_RemoveUFL(struct _userfilelist *elem)
{
  if(elem->prev!=NULL) {
    elem->prev->next=elem->next;
  }
  if(elem->next!=NULL) {
    elem->next->prev=elem->prev;
  }
  /* Element ausgeklinkt */
  if(elem->fullname!=NULL) _freesafe(elem->fullname);
  if(elem->name!=NULL) _freesafe(elem->name);
  if(elem->fullname_noext!=NULL) _freesafe(elem->fullname_noext);
  if(elem->name_noext!=NULL) _freesafe(elem->name_noext);
  _freesafe(elem);
  /* Alles freigegeben */
}

char *_NL_CreateNoExtName(char *name)
{
  char *rstr;
  int pos;
  rstr=(char*)_allocsafe(strlen(name)+1);
  strcpy(rstr,name);
  pos=strlen(rstr)-1;
  while(pos>0) {
    if(rstr[pos]=='/') break;
    if(rstr[pos]=='.') {
      /* Erster Punkt (von rechts) gefunden */
      rstr[pos]=0;
      /* String dort beenden */
      break;
    }
    pos--;
  }
  return rstr;
}

char *_NL_GetString4All(int flagnr,struct _userfilelist *firstufl,bool withapo)
{
  struct _userfilelist *tufl;
  long len,nr;
  char *tstr,*rstr;

  len=0;
  nr=0;
  tufl=firstufl;
  rstr=NULL;
  do {
    switch(flagnr) {
      case 1:
      case 5:tstr=tufl->name;
             break;
      case 3:
      case 7:tstr=tufl->fullname;
             break;
      case 9:
      case 13:if(tufl->name_noext==NULL) {
                tufl->name_noext=_NL_CreateNoExtName(tufl->name);
              }
              tstr=tufl->name_noext;
              break;
      case 11:
      case 15:if(tufl->fullname_noext==NULL) {
                tufl->fullname_noext=_NL_CreateNoExtName(tufl->fullname);
              }
              tstr=tufl->fullname_noext;
              break;
      default:tstr=NULL;
    }
    if(tstr==NULL) break;
    len+=strlen(tstr);
    nr++;
    tufl=tufl->next;
    if(tufl==NULL) break;
  } while(len<(EXE_STRING_LEN-1024-(3*nr)));
  if(nr>0) {
    tufl=firstufl;
    /* 3*nr fr "" und ein Space */
    rstr=(char*)_allocsafe(len+3*nr+1);
    rstr[0]=0;
    while(nr>0) {
      if(withapo==TRUE) {
        strcat(rstr,"\"");
      }
      switch(flagnr) {
        case 1:
        case 5:tstr=tufl->name;
               break;
        case 3:
        case 7:tstr=tufl->fullname;
               break;
        case 9:
        case 13:tstr=tufl->name_noext;
                break;
        case 11:
        case 15:tstr=tufl->fullname_noext;
                break;
      }
      strcat(rstr,tstr);
      if(withapo==TRUE) {
        strcat(rstr,"\"");
      }
      strcat(rstr," ");
      nr--;
      tufl=tufl->next;
    }
  }
  return rstr;
}


char *_NL_GetString()
{
  _GfxWin *gfxwin;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *nnsg;
  int w,h;
  char *rstr;
  bool okay=FALSE;

  w=strlen(_locale[200]);
  w*=_CharWidth;
  w+=50;
  h=3*_BBH+3*10;
  rstr=NULL;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,_locale[123],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateText(gfxwin,10,5+_CharHeight,1,_locale[200]);
    nnsg=_CreateStringGadget(gfxwin,10,10+_BBH,w-20,_NBH+6,"",256,_WConfig.unsel_pathfg,_WConfig.unsel_pathbg,_WConfig.sel_pathfg,_WConfig.sel_pathbg,3);
    _CreateButton(gfxwin,10,h-5-_BBH,(strlen(_locale[11])+2)*_CharWidth,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-(strlen(_locale[8])+2)*_CharWidth,h-5-_BBH,(strlen(_locale[8])+2)*_CharWidth,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    _HandleStringGadget(gfxwin,nnsg,NULL);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) okay=TRUE;
            else if(tbutton->data==2) okay=FALSE;
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } if(msg->type==KeyRelease) {
          if(msg->key==XK_Return) {
            okay=TRUE;
            _ReplyMessage(msg);
            break;
          } else if(msg->key==XK_Escape) {
            okay=FALSE;
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    if(okay==TRUE) {
      rstr=(char*)_allocsafe(strlen(nnsg->string)+1);
      strcpy(rstr,nnsg->string);
    }
    _CloseWindow(gfxwin);
  }
  return rstr;
}

char *_NL_GetString4Flag(int flagnr,struct _userfilelist **firstufl,struct _userfilelist **aktufl,bool *aktuflchanged,_RealLister *rl,int nr,bool withapo)
{
  char *rstr;
  int onr;
  struct _userfilelist *tufl,*tufl2;

  onr=(nr==1)?0:1;
  rstr=NULL;
  if(((*firstufl)!=NULL)||(flagnr>15)) {
    switch(flagnr) {
             /* hier wird der erste ausgewhlte Eintrag erfordert
                jeweils: ohne/mit Pfad und mit/ohne Ext. */
      case 0:
      case 4:rstr=(char*)_allocsafe(strlen((*aktufl)->name)+1+2);
             rstr[0]=0;
             if(withapo==TRUE) {
               strcat(rstr,"\"");
             }
             strcat(rstr,(*aktufl)->name);
             if(withapo==TRUE) {
               strcat(rstr,"\"");
             }
             break;
      case 2:
      case 6:rstr=(char*)_allocsafe(strlen((*aktufl)->fullname)+1+2);
             rstr[0]=0;
             if(withapo==TRUE) {
               strcat(rstr,"\"");
             }
             strcat(rstr,(*aktufl)->fullname);
             if(withapo==TRUE) {
               strcat(rstr,"\"");
             }
             break;
      case 8:
      case 12:if((*aktufl)->name_noext==NULL) {
                (*aktufl)->name_noext=_NL_CreateNoExtName((*aktufl)->name);
              }
              rstr=(char*)_allocsafe(strlen((*aktufl)->name_noext)+1+2);
              rstr[0]=0;
              if(withapo==TRUE) {
                strcat(rstr,"\"");
              }
              strcat(rstr,(*aktufl)->name_noext);
              if(withapo==TRUE) {
                strcat(rstr,"\"");
              }
              break;
      case 10:
      case 14:if((*aktufl)->fullname_noext==NULL) {
                (*aktufl)->fullname_noext=_NL_CreateNoExtName((*aktufl)->fullname);
               }
              rstr=(char*)_allocsafe(strlen((*aktufl)->fullname_noext)+1+2);
              rstr[0]=0;
              if(withapo==TRUE) {
                strcat(rstr,"\"");
              }
              strcat(rstr,(*aktufl)->fullname_noext);
              if(withapo==TRUE) {
                strcat(rstr,"\"");
              }
              break;
             /* und hier alle ausg... */
      case 9:
      case 11:
      case 13:
      case 15:
      case 1:
      case 3:
      case 5:
      case 7:rstr=_NL_GetString4All(flagnr,*firstufl,withapo);
             break;
      case 16:/* Pfad */
              if(rl->Dir[nr]!=NULL) {
                rstr=(char*)_allocsafe(strlen(rl->Dir[nr])+1);
                strcpy(rstr,rl->Dir[nr]);
              }
              break;
      case 17:/* anderen Pfad */
              if(rl->Dir[onr]!=NULL) {
                rstr=(char*)_allocsafe(strlen(rl->Dir[onr])+1);
                strcpy(rstr,rl->Dir[onr]);
              }
              break;
      case 18:/*linker Pfad */
              if(rl->Dir[0]!=NULL) {
                rstr=(char*)_allocsafe(strlen(rl->Dir[0])+1);
                strcpy(rstr,rl->Dir[0]);
              }
              break;
      case 19:/* rechter Pfad */
              if(rl->Dir[1]!=NULL) {
                rstr=(char*)_allocsafe(strlen(rl->Dir[1])+1);
                strcpy(rstr,rl->Dir[1]);
              }
              break;
      case 20:/* Textnachfrage */
              rstr=_NL_GetString();
              break;
    }
    /* die Informationen sind jetzt fertig, nun aber noch entsprechende Dateien deselektieren */
    switch(flagnr) {
      case 0:
      case 2:
      case 8:
      case 10:if((*aktufl)!=(*firstufl)) {
                tufl=(*aktufl)->next;
                if((*aktufl)->rootentry!=NULL) {
                  (*aktufl)->rootentry->select=FALSE;
                }
                _NL_RemoveUFL(*aktufl);
                *aktufl=tufl;
                *aktuflchanged=TRUE;
              } else {
                tufl=(*firstufl)->next;
                if((*aktufl)->rootentry!=NULL) {
                  (*aktufl)->rootentry->select=FALSE;
                }
                _NL_RemoveUFL(*aktufl);
                *firstufl=tufl;
                *aktufl=tufl;
                *aktuflchanged=TRUE;
              }
              break;
      case 1:
      case 3:
      case 9:
      case 11:tufl=*firstufl;
              while(tufl!=NULL) {
                tufl2=tufl->next;
                if(tufl->rootentry!=NULL) {
                  tufl->rootentry->select=FALSE;
                }
                _NL_RemoveUFL(tufl);
                tufl=tufl2;
              }
              *firstufl=NULL;
              *aktufl=NULL;
              break;
    }
  }
  return rstr;
}

struct _userfilelist *_NL_CreateUFL(_CDirEntry *dir)
{
  struct _userfilelist *first,*last,*tufl1;
  _CDirEntry *subdir;
  _FileEntry *fe;
  bool rootdir,takeentry;
  char *tstr;
  
  if(dir->parent==NULL) rootdir=TRUE; else rootdir=FALSE;
  /* erst alle Unterverzeichnisse durchgehen */
  subdir=dir->sub;
  first=last=NULL;
  while(subdir!=NULL) {
    tufl1=_NL_CreateUFL(subdir);
    if(tufl1!=NULL) {
      if(first==NULL) {
        first=tufl1;
        last=first;
        while(last->next!=NULL) last=last->next;
      } else {
        last->next=tufl1;
        last->next->prev=last;
        while(last->next!=NULL) last=last->next;
      }
    }
    subdir=subdir->right;
  }
  /* Nun noch alle normalen Dateien anhngen */
  fe=dir->first;
  while(fe!=NULL) {
    if(fe->prev!=NULL) {
      if((rootdir==FALSE)||((fe->select==TRUE)&&(fe->infilter==TRUE))) {
        if((S_ISDIR(fe->mode))&&(fe->iscorrupt==FALSE)) {
          takeentry=FALSE;
          if(fe->islink==TRUE) {
            takeentry=TRUE;
          }
        } else {
          takeentry=TRUE;
        }
        if(rootdir==TRUE) {
          /* Spezialfall: nicht rekursiv bearbeiten => auch Verz. aufnehmen */
          if(dir->sub==NULL) {
            takeentry=TRUE;
          }
        }
        if(takeentry==TRUE) {
          tufl1=_NL_NewUFL();
          tstr=(char*)_allocsafe(strlen(fe->fullname)+1);
          strcpy(tstr,fe->fullname);
          tufl1->fullname=tstr;
          tstr=(char*)_allocsafe(strlen(fe->name)+1);
          strcpy(tstr,fe->name);
          tufl1->name=tstr;
          if(rootdir==TRUE) {
            tufl1->rootentry=fe;
          }
          if(first==NULL) {
            first=last=tufl1;
          } else {
            last->next=tufl1;
            last->next->prev=last;
            last=last->next;
          }
        }
      }
    }
    fe=fe->next;
  }
  return first;
}

void _NL_UserCom(int pointerinfo,void *info)
{
  _ListView *lv;
  _RealLister *rl;
  int nr,onr,loopnr;
  _ListViewContent *lvc;
  int effheight,maxdisplayv,x,entry;
  char *tstr,*tmpname,*tmpoutput;
  long flag;
  _CDirEntry *maindir,*tdir1;
  char *com,*exestr,flagbuf[10],*returnstr,minbuf[2];
  unsigned long pos,endpos;
  bool finish,dorec,aktuflchanged,oldstate=FALSE;
  int flagnr;
  unsigned long byteanz,fileanz;
  struct _userfilelist *firstufl,*tufl,*aktufl;
/*  _GfxWin *gfxwin;*/
  FILE *fp;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  onr=(nr==1)?0:1;
  lv=mainstruct.lister[nr].lv;

  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
    com=((struct _buttondef*)info)->usercom;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
    com=((struct _filetypedef*)info)->usercom;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
    com=((struct _hotkeydef*)info)->usercom;
  } else {
    /* was soll ich machen ? */
    return;
  }
  effheight=lv->height-4-lv->hbar_height;
  maxdisplayv=_MaxDisplayV(mainwin,effheight);
  lvc=lv->first;
  entry=0;
  if(lvc!=NULL) {
    if(lvc->select==TRUE) {
      lvc->select=FALSE;
      _NL_SelectProc(lv,lvc);
      x=entry-lv->vbar_startpos+1;
      while(x>maxdisplayv) {
        lv->vbar_startpos++;
        lv->topcontent=lv->topcontent->next;
        x=entry-lv->vbar_startpos+1;
      }
      while(x<1) {
        lv->vbar_startpos--;
        lv->topcontent=lv->topcontent->prev;
        x=entry-lv->vbar_startpos+1;
      }
    }
    while(lvc->select==FALSE) {
      lvc=lvc->next;
      entry++;
      if(lvc==NULL) break;
    }
  }
  if((flag&2)==2) dorec=TRUE; else dorec=FALSE;
  /* Datenbank erstellen */
  maindir=(_CDirEntry*)_allocsafe(sizeof(_CDirEntry));
  maindir->parent=NULL;
  maindir->left=NULL;
  maindir->right=NULL;
  maindir->sub=NULL;
  maindir->first=rl->FEDir[nr];
  maindir->checked=FALSE;
  tstr=(char*)_allocsafe(1);
  tstr[0]=0;
  maindir->dirname=tstr;
  maindir->dirfullname=NULL;
  /* Erstellung der Database */
  if(pointerinfo==PISFILETYPE) {
    if(rl->activefe[nr]!=NULL) {
      oldstate=rl->activefe[nr]->select;
      rl->activefe[nr]->select=TRUE;
    }
  }
  else if((rl->dirnr[nr][0]==0)&&(rl->filenr[nr][0]==0)) {
    if(rl->activefe[nr]!=NULL) {
      oldstate=rl->activefe[nr]->select;
      rl->activefe[nr]->select=TRUE;
    }
  }
  if(dorec==TRUE) {
    _CreateDirLevel(maindir,0,&fileanz,&byteanz);
    tdir1=maindir->sub;
    while(tdir1!=NULL) {
      if((tdir1->sub==NULL)&&(tdir1->checked==FALSE)) {
        _CreateDirLevel(tdir1,0,&fileanz,&byteanz);
      } else {
        if((tdir1->sub!=NULL)&&(tdir1->sub->checked==FALSE)) {
          tdir1=tdir1->sub;
        } else {
          if((tdir1->sub!=NULL)&&(tdir1->sub->checked==FALSE)) {
            tdir1=tdir1->sub;
          } else if((tdir1->right!=NULL)&&(tdir1->right->checked==FALSE)) {
            tdir1=tdir1->right;
          } else {
            tdir1=tdir1->parent;
          }
        }
      }
    }
  }
  /* Grundstruktur erstellt */
  firstufl=_NL_CreateUFL(maindir);
  if(pointerinfo==PISFILETYPE) {
    if(rl->activefe[nr]!=NULL) {
      rl->activefe[nr]->select=oldstate;
    }
  }
  else if((rl->dirnr[nr][0]==0)&&(rl->filenr[nr][0]==0)) {
    if(rl->activefe[nr]!=NULL) {
      rl->activefe[nr]->select=oldstate;
    }
  }
  exestr=(char*)_allocsafe(EXE_STRING_LEN);
  /* Ende Init */
  /* Fenster ffnen */
/*  gfxwin=_OpenWindow(mainwin,0,0,100,50,100,100,100,50,50,50,0,"",PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateButton(gfxwin,10,10,80,30,_black,0,_locale[8],FALSE,_white,2,"",1);
    _RedrawWin(gfxwin);
    XFlush(_GlobalGUI.Dsp);
  }*/
  /* Start des Parsens */
  aktufl=firstufl;
  /* aktufl wird benutzt fr "first selected ...", damit kein Endlosloop entsteht */
  if(pointerinfo==PISFILETYPE) {
    tufl=firstufl;
    while(tufl!=NULL) {
      if(tufl->rootentry!=NULL) {
        if((tufl->rootentry)==rl->activefe[nr]) {
          aktufl=tufl;
          break;
        }
      }
      tufl=tufl->next;
    }
  }
  tmpname=_CreateTMPName();
  tmpoutput=_CreateTMPName();
  fp=fopen(tmpname,"w");
  if(fp!=NULL) {
    fprintf(fp,"#!/bin/sh\n");
    fprintf(fp,"cd \"%s\"\n",rl->Dir[nr]);
    for(loopnr=1;;loopnr++) {
      aktuflchanged=FALSE;
      exestr[0]=0;
      pos=0;
      finish=FALSE;
      while(com[pos]!=0) {
        if(com[pos]=='{') {
          endpos=pos+1;
          while(com[endpos]!='}') {
            if(com[endpos]==0) {
              finish=TRUE;
              break;
            }
            endpos++;
          }
          if(finish==FALSE) {
            /* nun ist das Flag zwischen pos und endpos */
            strncpy(flagbuf,com+pos,endpos-pos+1);
            flagbuf[endpos-pos+1]=0;
            flagnr=0;
            for(;;) {
              if(strcmp(_UFlags[flagnr],flagbuf)==0) break;
              flagnr++;
              if(flagnr>=UFLAGNR) break;
            }
            if(flagnr<UFLAGNR) {
              returnstr=_NL_GetString4Flag(flagnr,&firstufl,&aktufl,&aktuflchanged,rl,nr,((flag&32)==32)?TRUE:FALSE);
              if(returnstr!=NULL) {
                if((strlen(exestr)+strlen(returnstr)+1)<EXE_STRING_LEN) {
                  strcat(exestr,returnstr);
                } else finish=TRUE;
                _freesafe(returnstr);
              }
            }
            pos=endpos;
          }
        } else {
          minbuf[0]=com[pos];
          minbuf[1]=0;
          strcat(exestr,minbuf);
        }
        pos++;
        if(finish==TRUE) break;
        if((strlen(exestr)+1)>=EXE_STRING_LEN) break;
      }
      if(((flag&4)==0)&&((flag&8)==0)) {
        /* nicht in Terminal starten */
        if((flag&16)==16) {
          /* Ausgabe sammeln */
          if(loopnr==1) {
            strcat(exestr," >");
            strcat(exestr,tmpoutput);
          } else {
            strcat(exestr," >>");
            strcat(exestr,tmpoutput);
          }
        }
      }
      fprintf(fp,"%s\n",exestr);
      if((flag&1)==0) break; /* nur einmal ausfhren */
      if(aktuflchanged==FALSE) {
        if(aktufl!=NULL) aktufl=aktufl->next;
      }
      if(aktufl==NULL) break;
      if(pointerinfo==PISFILETYPE) break;
/*      if(gfxwin!=NULL) {
        if(_NL_CheckCancel(gfxwin)==TRUE) break;
      }*/
    }
    if(((flag&4)==4)||((flag&8)==8)) {
      /* in terminal starten */
      if((flag&8)==8) {
        fprintf(fp,"echo %s\n",_locale[201]);
        fprintf(fp,"read x\n");
      }
      sprintf(exestr,TERMINAL_BIN,tmpname);
    } else {
      sprintf(exestr,"%s",tmpname);
    }
    if(((flag&4)==0)&&((flag&8)==0)) {
      /* nicht in Terminal starten */
      if((flag&16)==16) {
        /* Ausgabe zeigen */
        fprintf(fp,OUTPUT_BIN,tmpoutput);
        fprintf(fp,"\n");
      }
    }
    fclose(fp);
    chmod(tmpname,0777);
    system(exestr);
  }
  /* die tmp-Dateien wieder lschen, damit's nicht zuviel wird */
  remove(tmpname);
  remove(tmpoutput);
  _freesafe(tmpname);
  _freesafe(tmpoutput);
  /* Ende */
  /* Struktur wieder freilassen */
  _NL_FreeDirList(maindir);
  while(firstufl!=NULL) {
    tufl=firstufl->next;
    _NL_RemoveUFL(firstufl);
    firstufl=tufl;
  }
  _freesafe(exestr);
/*  if(gfxwin!=NULL) _CloseWindow(gfxwin);*/
  if((flag&64)==64) {
    /* Lister aktualisieren */
    _NL_UpdateDir(PISNUMBER,&nr);
  } else {
    _NL_RebuildLister(nr);
  }
  if((flag&128)==128) {
    /* anderen Lister aktualisieren */
    if(mainstruct.lister[onr].activemode==0) {
      _NL_UpdateDir(PISNUMBER,&onr);
    }
  }
}

/****************************************************************************************
  Ende UserCom-Fkt.
 ****************************************************************************************/

void _NL_CheckNextFile()
{
  _ListView *lv;
  _RealLister *rl;
  int nr;
  _ListViewContent *lvc;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  if(rl->filesunchecked==TRUE) {
    for(nr=0;nr<2;nr++) {
      if(mainstruct.lister[nr].activemode==0) {
        if(rl->nextcheck[nr]!=NULL) {
          _CheckFiletype(rl->nextcheck[nr]);
          lv=mainstruct.lister[nr].lv;
          lvc=lv->first;
          while(lvc->data!=(rl->nextcheck[nr])->nr) {
            lvc=lvc->next;
            if(lvc==NULL) break;
          }
          if(lvc!=NULL) {
            _BuildLVC(rl->nextcheck[nr],lvc,nr);
            _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
            _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
          }
          rl->nextcheck[nr]=rl->nextcheck[nr]->next;
        }
      }
    }
    if((rl->nextcheck[0]==NULL)&&(rl->nextcheck[1]==NULL)) rl->filesunchecked=FALSE;
  }
}

/********************************************************************
  RunProgram-Funktion
 ********************************************************************/
 
void _NL_RunProgram(int pointerinfo,void *info)
{
  _GfxWin *gfxwin;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *nnsg;
  _FileEntry *fe;
  int w,h;
  char *tstr;
  bool okay=FALSE;
  _ListView *lv;
  _RealLister *rl;
  int nr;
  long flag;
  char *path,*exename,*exestr,*tmpname,*tmpoutput;
  FILE *fp;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  lv=mainstruct.lister[nr].lv;

  path=(char*)_allocsafe(1);
  path[0]=0;
  exename=(char*)_allocsafe(1);
  exename[0]=0;
  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }
  if((flag&16)==16) {
    if(_RequestActionFlags(&flag,RUNPROGRAM)==FALSE) {
      _freesafe(path);
      _freesafe(exename);
      return;
    }
  }
/*  if((pointerinfo==PISHOTKEY)||(pointerinfo==PISFILETYPE)||(pointerinfo==PISBUTTON)) {*/
    if(rl->FEDir[nr]!=NULL) {
      tstr=(char*)_allocsafe(strlen(rl->Dir[nr])+1);
      strcpy(tstr,rl->Dir[nr]);
      _freesafe(path);
      path=tstr;
      if(rl->activefe[nr]!=NULL) {
        tstr=(char*)_allocsafe(strlen(rl->activefe[nr]->name)+1);
        strcpy(tstr,rl->activefe[nr]->name);
        _freesafe(exename);
        exename=tstr;
      } else {
        fe=rl->FEDir[nr]->next;
        while(fe!=NULL) {
          if((fe->select==TRUE)&&(fe->infilter==TRUE)) break;
          fe=fe->next;
        }
        if(fe!=NULL) {
          tstr=(char*)_allocsafe(strlen(fe->name)+1);
          strcpy(tstr,fe->name);
          _freesafe(exename);
          exename=tstr;
        }
      }
    }
/*  }*/
  w=strlen(_locale[202]);
  w*=_CharWidth;
  w+=20;
  h=3*_BBH+3*10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,_localecoms[RUNPROGRAM],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateText(gfxwin,10,5+_CharHeight,1,_locale[202]);
    nnsg=_CreateStringGadget(gfxwin,10,10+_BBH,w-20,_NBH+6,exename,256,_WConfig.unsel_pathfg,_WConfig.unsel_pathbg,_WConfig.sel_pathfg,_WConfig.sel_pathbg,3);
    _CreateButton(gfxwin,10,h-5-_BBH,(strlen(_locale[11])+2)*_CharWidth,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-(strlen(_locale[8])+2)*_CharWidth,h-5-_BBH,(strlen(_locale[8])+2)*_CharWidth,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    _HandleStringGadget(gfxwin,nnsg,NULL);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) okay=TRUE;
            else if(tbutton->data==2) okay=FALSE;
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } if(msg->type==KeyRelease) {
          if(msg->key==XK_Return) {
            okay=TRUE;
            _ReplyMessage(msg);
            break;
          } else if(msg->key==XK_Escape) {
            okay=FALSE;
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    if(okay==TRUE) {
      tstr=(char*)_allocsafe(strlen(nnsg->string)+1);
      strcpy(tstr,nnsg->string);
      _freesafe(exename);
      exename=tstr;
    }
    _CloseWindow(gfxwin);
    /* ausfhren */
    if(okay==TRUE) {
      tmpname=_CreateTMPName();
      tmpoutput=_CreateTMPName();
      fp=fopen(tmpname,"w");
      if(fp!=NULL) {
        fprintf(fp,"#!/bin/sh\n");
/*        if((flag&8)==0) {*/
          fprintf(fp,"cd \"%s\"\n",path);
/*        }*/
        if((strlen(path)>0)&&((flag&8)==0)) {
          fprintf(fp,"./%s",exename);
        } else {
          fprintf(fp,"%s",exename);
        }
        if(((flag&1)==0)&&((flag&2)==0)) {
          /* nicht in Terminal starten */
          if((flag&4)==4) {
            /* Ausgabe */
            fprintf(fp," >%s\n",tmpoutput);
            fprintf(fp,OUTPUT_BIN,tmpoutput);
          }
        }
        fprintf(fp,"\n");
        if((flag&2)==2) {
          fprintf(fp,"echo %s\n",_locale[201]);
          fprintf(fp,"read x\n");
        }
        fclose(fp);
        chmod(tmpname,0777);
        if(((flag&1)==1)||((flag&2)==2)) {
          exestr=(char*)_allocsafe(strlen(TERMINAL_BIN)+strlen(tmpname)+1);
          sprintf(exestr,TERMINAL_BIN,tmpname);
        } else {
          exestr=(char*)_allocsafe(strlen(tmpname)+1);
          sprintf(exestr,"%s",tmpname);
        }
        system(exestr);
        _freesafe(exestr);
      }
      remove(tmpname);
      remove(tmpoutput);
      _freesafe(tmpname);
      _freesafe(tmpoutput);
    }
  }
  _freesafe(path);
  _freesafe(exename);
}

/********************************************************************
  Ende RunProgram-Funktion
 ********************************************************************/

/********************************************************************
  MainFunc-Funktion
 ********************************************************************/

void _NL_MainFunc(int pointerinfo,void *info)
{
  int nr;
  _FileEntry *fe;
  _RealLister *rl;
  struct _filetypedef *ft;
  bool exe;
  void (*prog)(int,void *);

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  fe=rl->activefe[nr];
  if(fe==NULL) return;
  if(S_ISDIR(fe->mode)) {
    _NL_GoDir(fe,NULL);
  } else {
    exe=_NL_Check4Exe(fe);
    if(exe==TRUE) {
      _NL_RunProgram(PISNOTHING,NULL);
    } else {
      if(fe->filetypeindex>=0) {
        ft=fe->filetype;
        if(ft!=NULL) {
          prog=mainstruct.mode_info[0].prog[ft->comnr];
          if(prog!=NULL) (prog)(PISFILETYPE,ft);
        }
      }
    }
  }
}

/********************************************************************
  Ende MainFunc-Funktion
 ********************************************************************/

/********************************************************************
  FilterSelect-Funktion
 ********************************************************************/

void _NL_FilterSelect(int pointerinfo,void *info)
{
  _GfxWin *gfxwin;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *nnsg;
  _FileEntry *fe;
  int w,h;
  char *pattern;
  bool okay=FALSE;
  _ListView *lv;
  _RealLister *rl;
  int nr;
  long flag;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  lv=mainstruct.lister[nr].lv;

  if(rl->FEDir[nr]==NULL) return;

  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }
  pattern=NULL;
  w=strlen(_locale[203]);
  w*=_CharWidth;
  w+=20;
  h=3*_BBH+3*10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,_localecoms[FILTERSELECT],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateText(gfxwin,10,5+_CharHeight,1,_locale[203]);
    nnsg=_CreateStringGadget(gfxwin,10,10+_BBH,w-20,_NBH+6,"*",256,_WConfig.unsel_pathfg,_WConfig.unsel_pathbg,_WConfig.sel_pathfg,_WConfig.sel_pathbg,3);
    _CreateButton(gfxwin,10,h-5-_BBH,(strlen(_locale[11])+2)*_CharWidth,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-(strlen(_locale[8])+2)*_CharWidth,h-5-_BBH,(strlen(_locale[8])+2)*_CharWidth,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    _HandleStringGadget(gfxwin,nnsg,NULL);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) okay=TRUE;
            else if(tbutton->data==2) okay=FALSE;
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } if(msg->type==KeyRelease) {
          if(msg->key==XK_Return) {
            okay=TRUE;
            _ReplyMessage(msg);
            break;
          } else if(msg->key==XK_Escape) {
            okay=FALSE;
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    if(okay==TRUE) {
      pattern=(char*)_allocsafe(strlen(nnsg->string)+1);
      strcpy(pattern,nnsg->string);
    }
    _CloseWindow(gfxwin);
    if(okay==TRUE) {
      if(strlen(pattern)>0) {
        fe=rl->FEDir[nr]->next;
        while(fe!=NULL) {
          if(fe->infilter==TRUE) {
            if(fnmatch(pattern,fe->name,0)==0) {
              fe->select=TRUE;
            } else {
/*              fe->select=FALSE;*/
            }
          }
          fe=fe->next;
        }
        _NL_RebuildLister(nr);
      }
    }
    if(pattern!=NULL) _freesafe(pattern);
  }
}

/********************************************************************
  Ende FilterSelect-Funktion
 ********************************************************************/

/********************************************************************
  DirSize-Funktion
 ********************************************************************/

void _NL_DirSize(int pointerinfo,void *info)
{
  _ListView *lv;
  _RealLister *rl;
  int nr;
  _FileEntry *fe;
  char *tstr;
  long flag;
  _CDirEntry *maindir,*tdir1;
  unsigned long byteanz,fileanz,size;
  bool abbruch;
  struct _solidbutton *statebar;
  _Message *msg;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  lv=mainstruct.lister[nr].lv;

  if(rl->FEDir[nr]==NULL) return;
  if((rl->dirnr[nr][0]==0)&&(rl->filenr[nr][0]==0)) return;

  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }
  statebar=mainstruct.statebar;
  maindir=(_CDirEntry*)_allocsafe(sizeof(_CDirEntry));
  maindir->parent=NULL;
  maindir->left=NULL;
  maindir->right=NULL;
  maindir->sub=NULL;
  maindir->first=rl->FEDir[nr];
  maindir->checked=FALSE;
  maindir->ops_perm=0;
  maindir->error_occ=FALSE;
  tstr=(char*)_allocsafe(1);
  tstr[0]=0;
  maindir->dirname=tstr;
  maindir->dirfullname=NULL;
  /* Erstellung der Database */
  _CreateDirLevel(maindir,0,&fileanz,&byteanz);
  tdir1=maindir->sub;
  abbruch=FALSE;
  size=0;
  fe=maindir->first->next;
  while((tdir1!=NULL)&&(abbruch==FALSE)) {
    if((tdir1->sub==NULL)&&(tdir1->checked==FALSE)) {
      if(tdir1->dirfullname!=NULL) {
        tstr=dupstring(tdir1->dirfullname);
        _freesafe(statebar->text);
        statebar->text=tstr;
        _GUIDrawSolidButton(mainwin,statebar,BUFFER);
        _FlushWin(mainwin,statebar->x,statebar->y,statebar->width,statebar->height);
        XFlush(_GlobalGUI.Dsp);
      }
      _CreateDirLevel(tdir1,0,&fileanz,&byteanz);
      size+=byteanz;
    } else {
      if((tdir1->sub!=NULL)&&(tdir1->sub->checked==FALSE)) {
        tdir1=tdir1->sub;
      } else {
        if((tdir1->sub!=NULL)&&(tdir1->sub->checked==FALSE)) {
          tdir1=tdir1->sub;
        } else if((tdir1->right!=NULL)&&(tdir1->right->checked==FALSE)) {
          if(tdir1->parent!=NULL) {
            if(tdir1->parent->parent==NULL) {
              /* nchstes ausgewhltes Verz. suchen */
              while(fe!=NULL) {
                if(fe->islink==FALSE) {
                  if(S_ISDIR(fe->mode)) {
                    if(fe->select==TRUE) break;
                  }
                }
                fe=fe->next;
              }
              if(fe!=NULL) {
                fe->dirsize=size;
                fe->select=FALSE;
              }
              size=0;
            }
          }
          tdir1=tdir1->right;
        } else {
          if(tdir1->parent!=NULL) {
            if(tdir1->parent->parent==NULL) {
              /* nchstes ausgewhltes Verz. suchen */
              while(fe!=NULL) {
                if(fe->islink==FALSE) {
                  if(S_ISDIR(fe->mode)) {
                    if(fe->select==TRUE) break;
                  }
                }
                fe=fe->next;
              }
              if(fe!=NULL) {
                fe->dirsize=size;
                fe->select=FALSE;
              }
              size=0;
            }
          }
          tdir1=tdir1->parent;
        }
      }
    }
    /* hier auf ESC-taste checken */
    while((msg=_GetMessage(mainwin))!=NULL) {
      if(msg->type==KeyRelease) {
        if(msg->key==XK_Escape) {
          abbruch=TRUE;
          _ReplyMessage(msg);
          break;
        }
      }
      _ReplyMessage(msg);
    }
  }
  /* Database lschen */
  _NL_FreeDirList(maindir);
  _NL_RebuildLister(nr);
}

/********************************************************************
  Ende DirSize-Funktion
 ********************************************************************/

/********************************************************************
  CreateSymlink-Funktion
 ********************************************************************/

void _NL_CreateSymlink(int pointerinfo,void *info)
{
  _FileEntry *fe;
  _ListViewContent *lvc;
  struct stat statbuf;
  char *newname,*tstr,*tstr2,*infotext[2],*buttontext[2];
  int x,entry,effheight,maxdisplayv=0,error;
  bool nameok,abbruch,opok,takeactive,oldstate=FALSE;
  _ListView *lv;
  _RealLister *rl;
  int nr,destnr,onr;
  long flag;
  char *destpath;

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  onr=(nr==0)?1:0;
  lv=mainstruct.lister[nr].lv;

  if(rl->FEDir[nr]==NULL) return;
  takeactive=FALSE;
  if((rl->dirnr[nr][0]==0)&&(rl->filenr[nr][0]==0)) {
    if(rl->activefe[nr]==NULL) return;
    else takeactive=TRUE;
  }

  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }
  if((flag&4)==4) {
    if(_RequestActionFlags(&flag,CREATESYMLINK)==FALSE) {
      return;
    }
  }

  destnr=onr;
  if((flag&1)==1) destnr=nr;
  else {
    if(mainstruct.lister[onr].activemode!=0) destnr=nr;
    else {
      if(strlen(rl->Dir[onr])==0) destnr=nr;
    }
  }
  destpath=(char*)_allocsafe(strlen(rl->Dir[destnr])+2);
  strcpy(destpath,rl->Dir[destnr]);
  if(strlen(destpath)>1) strcat(destpath,"/");

  fe=rl->FEDir[nr];
  lvc=lv->first;
  entry=0;
  if(lvc->select==TRUE) {
    lvc->select=FALSE;
    _NL_SelectProc(lv,lvc);
    x=entry-lv->vbar_startpos+1;
    while(x>maxdisplayv) {
      lv->vbar_startpos++;
      lv->topcontent=lv->topcontent->next;
      x=entry-lv->vbar_startpos+1;
    }
    while(x<1) {
      lv->vbar_startpos--;
      lv->topcontent=lv->topcontent->prev;
      x=entry-lv->vbar_startpos+1;
    }
  }
  while(lvc->select==FALSE) {
    if(takeactive==TRUE) {
      if(lvc->active==TRUE) {
        lvc->select=TRUE;
        break;
      }
    }
    lvc=lvc->next;
    entry++;
    if(lvc==NULL) break;
  }
  abbruch=FALSE;
  effheight=lv->height-4-lv->hbar_height;
  maxdisplayv=_MaxDisplayV(mainwin,effheight);
  if(takeactive==TRUE) {
    oldstate=rl->activefe[nr]->select;
    rl->activefe[nr]->select=TRUE;
  }
  while((fe!=NULL)&&(abbruch==FALSE)) {
    if((fe->select==TRUE)&&(fe->infilter==TRUE)) {
      opok=FALSE;
      if(fe->prev!=NULL) {
        nameok=FALSE;
        while(nameok==FALSE) {
          newname=StringRequest(fe->name,_localecoms[CREATESYMLINK],_locale[207]);
          if(newname!=NULL) {
            tstr=(char*)_allocsafe(strlen(destpath)+strlen(newname)+1);
            strcpy(tstr,destpath);
            strcat(tstr,newname);
            error=stat(tstr,&statbuf);
            if(error!=0) {
              _freesafe(newname);
              newname=tstr;
              nameok=TRUE;
            } else {
              tstr2=(char*)_allocsafe(strlen(_locale[133])+strlen(tstr)+1);
              sprintf(tstr2,_locale[133],tstr);
              infotext[0]=tstr2;
              infotext[1]=_locale[150];
              buttontext[0]=_locale[11];
              buttontext[1]=_locale[8];
              x=_Request(_locale[125],2,infotext,2,buttontext);
              _freesafe(infotext[0]);
              _freesafe(newname);
              _freesafe(tstr);
              if(x==0) {
                nameok=FALSE;
              } else {
                nameok=TRUE;
                newname=NULL;
                abbruch=TRUE;
              }
            }
          } else {
            nameok=TRUE;
            abbruch=TRUE;
          }
        }
        if((newname!=NULL)&&(abbruch==FALSE)) {
            /* newname heit der link */
          if((flag&2)==2) {
            if(symlink(fe->name,newname)==0) opok=TRUE;
          } else {
            if(symlink(fe->fullname,newname)==0) opok=TRUE;
          }
          if(opok==FALSE) {
            tstr2=(char*)_allocsafe(strlen(_locale[205])+strlen(newname)+1);
            sprintf(tstr2,_locale[205],newname);
            infotext[0]=tstr2;
            buttontext[0]=_locale[11];
            buttontext[1]=_locale[8];
            x=_Request(_locale[125],1,infotext,2,buttontext);
            _freesafe(infotext[0]);
            if(x!=0) {
              abbruch=TRUE;
            }
          }
          _freesafe(newname);
        }
      }
      if(opok==TRUE) DeSelect(&entry,maxdisplayv,lv,&lvc);
      else {
        lvc=lvc->next;
        entry++;
        if(lvc!=NULL) {
          while(lvc->select==FALSE) {
            lvc=lvc->next;
            entry++;
            if(lvc==NULL) break;
          }
        }
      }
    }
    fe=fe->next;
  }
  if(takeactive==TRUE) {
    rl->activefe[nr]->select=oldstate;
  }
  _freesafe(destpath);
  if(destnr!=nr) {
    _NL_RebuildLister(nr);
    _NL_UpdateDir(PISNUMBER,&destnr);
  } else {
    _NL_UpdateDir(PISNUMBER,&nr);
  }
}

/********************************************************************
  Ende CreateSymlink-Funktion
 ********************************************************************/

/********************************************************************
  ChangeSymlink-Funktion
 ********************************************************************/

void _NL_ChangeSymlink(int pointerinfo,void *info)
{
  _FileEntry *fe;
  _ListViewContent *lvc;
  char *newname,*tstr2,*infotext[2],*buttontext[2];
  int x,entry,effheight,maxdisplayv=0;
  bool abbruch,opok,takeactive,oldstate=FALSE;
  _ListView *lv;
  _RealLister *rl;
  int nr;
  long flag;
  char buffer[4096];

  rl=(_RealLister*)mainstruct.mode_info[0].special_info;
  nr=mainstruct._ActiveLV;
  lv=mainstruct.lister[nr].lv;

  if(rl->FEDir[nr]==NULL) return;
  takeactive=FALSE;
  if((rl->dirnr[nr][0]==0)&&(rl->filenr[nr][0]==0)) {
    if(rl->activefe[nr]==NULL) return;
    else takeactive=TRUE;
  }

  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }

  fe=rl->FEDir[nr];
  lvc=lv->first;
  entry=0;
  if(lvc->select==TRUE) {
    lvc->select=FALSE;
    _NL_SelectProc(lv,lvc);
    x=entry-lv->vbar_startpos+1;
    while(x>maxdisplayv) {
      lv->vbar_startpos++;
      lv->topcontent=lv->topcontent->next;
      x=entry-lv->vbar_startpos+1;
    }
    while(x<1) {
      lv->vbar_startpos--;
      lv->topcontent=lv->topcontent->prev;
      x=entry-lv->vbar_startpos+1;
    }
  }
  while(lvc->select==FALSE) {
    if(takeactive==TRUE) {
      if(lvc->active==TRUE) {
        lvc->select=TRUE;
        break;
      }
    }
    lvc=lvc->next;
    entry++;
    if(lvc==NULL) break;
  }
  abbruch=FALSE;
  effheight=lv->height-4-lv->hbar_height;
  maxdisplayv=_MaxDisplayV(mainwin,effheight);
  if(takeactive==TRUE) {
    oldstate=rl->activefe[nr]->select;
    rl->activefe[nr]->select=TRUE;
  }
  while((fe!=NULL)&&(abbruch==FALSE)) {
    if((fe->select==TRUE)&&(fe->infilter==TRUE)) {
      opok=FALSE;
      if(fe->prev!=NULL) {
        if(fe->islink==TRUE) {
          x=readlink(fe->fullname,buffer,4095);
          if(x>=0) {
            buffer[x]=0;
            newname=StringRequest(buffer,_localecoms[CHANGESYMLINK],_locale[206]);
            if(newname==NULL) {
              abbruch=TRUE;
            }
            if((newname!=NULL)&&(abbruch==FALSE)) {
              if(remove(fe->fullname)==0) {
                if(symlink(newname,fe->fullname)==0) opok=TRUE;
                if(opok==FALSE) {
                  tstr2=(char*)_allocsafe(strlen(_locale[205])+strlen(newname)+1);
                  sprintf(tstr2,_locale[205],newname);
                  infotext[0]=tstr2;
                   buttontext[0]=_locale[11];
                  buttontext[1]=_locale[8];
                  x=_Request(_locale[125],1,infotext,2,buttontext);
                  _freesafe(infotext[0]);
                  if(x!=0) {
                    abbruch=TRUE;
                  }
                }
              } else {
              }
              _freesafe(newname);
            }
          }
        }
      }
      if(opok==TRUE) DeSelect(&entry,maxdisplayv,lv,&lvc);
      else {
        lvc=lvc->next;
        entry++;
        if(lvc!=NULL) {
          while(lvc->select==FALSE) {
            lvc=lvc->next;
            entry++;
            if(lvc==NULL) break;
          }
        }
      }
    }
    fe=fe->next;
  }
  if(takeactive==TRUE) {
    rl->activefe[nr]->select=oldstate;
  }
  _NL_UpdateDir(PISNUMBER,&nr);
}

/********************************************************************
  Ende ChangeSymlink-Funktion
 ********************************************************************/

