#ifndef _NORMALMODE_H
#define _NORMALMODE_H

#include "wtypes.h"
#include "lowlevelfunc.h"
#include "COMS.h"
#include "AGUI-X.h"
#include "CONFIG.h"
#include "file.h"

typedef struct _cdirentry { struct _cdirentry *parent;
                            struct _cdirentry *sub;
                            struct _cdirentry *left;
                            struct _cdirentry *right;
                            _FileEntry *first;
                            char *dirname;
                            char *dirfullname;
                            mode_t mode;
                            int ops_perm;
                            bool checked;
                            bool error_occ; } _CDirEntry;

void _NL_on(int nr);
void _NL_off(int nr);
void _NL_activate(void);
void _NL_deactivate(void);
void _NL_Shutdown(void);
void _NL_RebuildLister(int nr);
int _NL_SetDir(const char *path,int nr);
void _UpdateStatebar(void);
void _NL_UpdateDir(int pointerinfo,void *info);
int _NL_SelectProc(_ListView *lv,_ListViewContent *lvc);
void _NL_CheckAction(_ListViewContent *lvc);
void _NL_GoDir(_FileEntry *fe,char *dirnamereturn);
void _NL_Up(int pointerinfo,void *info);
void _NL_Down(int pointerinfo,void *info);
void _NL_Left(int pointerinfo,void *info);
void _NL_Right(int pointerinfo,void *info);
void _NL_Home(int pointerinfo,void *info);
void _NL_End(int pointerinfo,void *info);
void _NL_PageUp(int pointerinfo,void *info);
void _NL_PageDown(int pointerinfo,void *info);
void _NL_SelectActive(int pointerinfo,void *info);
void _NL_CheckFilterAll(int nr);
void _NL_UpdateStatebar(void);
void _NL_SelectAllOp(int pointerinfo,void *info);
void _NL_SelectNoneOp(int pointerinfo,void *info);
void _NL_InvertOp(int pointerinfo,void *info);
void _NL_CopyOp(int pointerinfo,void *info);
void _NL_DeleteOp(int pointerinfo,void *info);
void _NL_RenameOp(int pointerinfo,void *info);
void _NL_MakeDirOp(int pointerinfo,void *info);
void _NL_MoveOp(int pointerinfo,void *info);
void _NL_UserCom(int pointerinfo,void *info);
void _NL_CheckNextFile();
void _NL_RunProgram(int pointerinfo,void *info);
void _NL_MainFunc(int pointerinfo,void *info);
void _NL_FilterSelect(int pointerinfo,void *info);
void _NL_DirSize(int pointerinfo,void *info);
void _NL_CreateSymlink(int pointerinfo,void *info);
void _NL_ChangeSymlink(int pointerinfo,void *info);
bool _NL_CheckCancel(_GfxWin *gfxwin);

/* nicht clever, da sie in progs.c liegen */
int _Request(char *title,int lines,char *text[],int buttons,char *buttontext[]);
char *_RequestNewName(char *oldname);
bool _RequestActionFlags(long *flag,int commando);
char *_CreateTMPName();
char *StringRequest(char *oldname,char *title,char *text);

#endif
